' #################################################################################################################
' EchoLinkPlus.vbs 
' Authors: DK6XH & DC4FS
' Exec-Modul zu EchoLinkPlus
' Date: 30. August 2004
' Version: 2.1.5b Build 06  30.08.2004 - 12:00
' #################################################################################################################
'
' ###### NEU ###### Zeile 2042 # WScript.Sleep 500 # zur Vermeidung doppelter Ansage langer Texte
'
'
'
' EchoLinkPlus ist ein Zusatzprogramm zu "EchoLink.exe", das speziell zur Anpassung von EchoLink an den Betrieb
' mit automatischen Stationen (z. B. Repeater) entwickelt wurde. Die Kommunikation erfolgt ueber die 
' Programmierschnittstelle zum implementierten COM Automationsserver.
'
' HINWEISE:
' ---------
' - Dieses Script startet automatisch das Programm "Echolink.exe".
'
' - !! Dieses Script ist nur lauffaehig, wenn vorher das KonfigurationsScript "EchoLinkPlusConfig.vbs" entsprechend
'   konfiguriert und die Parameter und Werte gespeichert wurden!!

' - Das KonfigurationsScript "EchoLinkPlusConfig.vbs" kann beliebig oft geaendert werden und waehrend der Laufzeit
'   des Programms "EchoLink.exe" mit "EchoLinkPlus.vbs" gestartet werden. Die jeweils geaenderten Parameter werden
'   dann beim naechsten Update (zyklisch oder manuell) der EchoLink-Stationsliste automatisch uebernommen.

' - EchoLinkPlus sollte  N I C H T  mit "WScript.exe" sondern mit "CScript.exe" ausgefuehrt werden.
'	Eingabe ueber Befehlszeile
'								cscript //H:cscript 
'	oder BAT-Datei:
'						[StartEchoLink.bat]
'								cscript //H:cscript
'								C:\Programme\K1RFD\EchoLink\scripts\EchoLinkPlus.vbs
'	 
'	Detaillierte Informationen hierzu:
'   www.it-visions.de/default2.aspx?start=http://www.it-visions.de/(zr0fh3nkburuco4505yrcfm2)/lserver/faq.aspx?g=scripting
'	sowie "EchoLinkPlus_Hilfe.chm".
'
' #################################################################################################################


'	Option Explicit
	On Error Resume Next 


'#################################################
'Definition der Variablen, Laden der Konfiguration
'#################################################

	Dim ActConnect, AdverSwitchOff, AdverSwOffCount, AgainConnect, AnnBusyTime, AnnCall, Announcements, AnnIfNotRxOn, AnnIfNotTraff, AnnActTime, AutoDisc, CallCount, ChkDiscLink 
	Dim ChkLinkRes, ClearPrivSub, ClearToAnn, ClearToReConnect, CommandActive, ConnectGuard, DiscEvent, DTMFCommand, InfoEchoEnab, InfoEchoToPlay, LastConnect, Link, LocalRxOn
	Dim LocalRxOnS, noDTMF, OwnNodeNumber, Password, PeersCount, PreCmdDTMF, PrioLocTraff, PriorLocalTraff, RecOffCount, RecOn, RecOnCount, RecOnCountS, OpenRep, Digits, AnnBusyS
	Dim PTTWDCount, PreCmdChar, RepeaterMode, ELinkEnabTrigg, ErrorCheck, GetActTime, InfoEcho, StationMode, SuspLocOnly, SuspTemp, SuspLocalOnly, SysopMode, SysopTime, FirstEcho
	Dim TempBusyS, TimerOn, WavCallDir, WavInfoEchoDir, RepHoldTimeCount, ResetTime, RXOn, RxOnCount, RxOnCountS, InfoEchoBeep, bCallIfELBusy, bDTMFDecoder, bInactivityTimeout, sDigits
	Dim bReceivetimeout, sEchoLinkBusy, sLinkFree, sLocalBusy, tAnnBusyTime, tAskPreTraffRec, tAskPreTraffRX, tAudioDelay, tBusyHoldTime, tLocalRxOnS, tLocalRxOn, tPreOpenRepSI
	Dim tPreOpenRepTS, tPreOpenRepDur, tAnnCall, tReconnectTime, tRepHoldTime, QuickConnect, AnnStn, LenAnnStn, AnnStnCon, AnnStnLin, AnnStnRep, CharToPlay, CommandActiveTime
	Dim GuardAutoDiscAgain, GuardCallCount, tSuspTempOff, tSuspTempOn, tInfoEchoOff, tInfoEchoOn, tLocalOnlyDay, tLocalOnlyHourOff, tLocalOnlyMinOff, tLocalOnlyHourOn, tLocalOnlyMinOn
	Dim AnnTime, AnnTimeSig, AnnTimeVoice, AnnActMsg, NumberActMsg, PreOpenRepeater, WavTimeDir, WavActTimeDir, WavActMsgDir, ATV, ATVoice, JustConnected, iCount, jCount, kCount, lCount
	Dim sStation, ConnectingCall, EndOfScript, SelCall, AskPreTraff, AnnFree,ClearToAnnDelay, ClearToKillLink, sConnectingTo, BannedCallsign, CallsignDeny, DenyConn, MaxPeers, bRX
	Dim FileName, WavFileTime, CallWavFileTime, CallToPlay, InfoEchoToPlayTime, FileToPlayTime, StationOnline, StationBusy, ConnectingTo, CallToPlayTime, CharToPlayTime, FileToPlay
	Dim tRepPostTime, DispBusy, ListenOn, ValDisconn, CheckMaxPeers, ShortCut, ShortCutList, ShortCutDir, DTMFstringRec, AnnIfNotEnabEL, sChar, sCharX, length, DTMFstring
	Dim ActSec, ActMin, ActHour, ActDay, DActsec, ToneFrequ, oStation, ConnectGuardTime, AnnTimeEnab, NumberOfCallFile, MsgToPlay, MsgToPlayTime, SelActMsg, SelCallMaleFemale
	Dim bTransmitTimeout, AnnounceHour, RefreshInterval, RefreshIntervalELP, AutoUpdateELP, UpdateInQSOELP, TimeToPlay, TimeToPlayTime, MinToPlay, MinToPlayTime, DiscLink
	Dim SysAnnELPlus, PTTSwitchEnable, doneAnnCall, doneTimeSignal, doneAnnTime, doneAnnActMsg, StationListRec, StationConnected, WavStnCallDir, Header, PopupMsg, AnnActMsgSysOp
	Dim StartupProfile, RegKeyEL, RegKeyELP, SelAnnMaleFemale, sStatusELP, sReconnectELP, DispInactTimeout, sLocationFree, ELinkEnab, ELinkEnabAkt, Stunden, Minuten
	Dim oWshShell, oEchoLink, oStations, ConfEchoLink, FileSO, FileN, FileSysObj, ShortCutFile, sEchoLinkBusyCall, CloseELP, ClsELP, CloseELPCount, RxOrRec
	Dim aStationList(6000, 2), tStationList(6000,2), SLCount, SearchCount, TransferStatList, BreakTime, sStatus, sStationStatus, sStationMode
	Dim PathEchoLink, SysLogLastLine, ReadLine, ConnectingTime, bTimeoutTrying, ConnectingToNode, AnnConnecting

	Set oEchoLink = WScript.CreateObject("EchoLink.EchoLinkSession", "EchoLink_")
	Set ConfEchoLink = oEchoLink.SystemConfig
	WScript.Sleep 1000
	sStation = ConfEchoLink.Callsign
	ConfEchoLink.Apply 0
	Header = "   EchoLink+ V2.1.5 [DK6XH & DC4FS]"
	sStationMode = Right(sStation, 2)			'Eigene Station: Repeater (-R) oder Link (-L) ?
	LoadConfig			' Konfiguration laden
	If Err.Number <> 0 Then
		oWshShell.Popup "Es ist ein Fehler augetreten" & (Chr(13) & Chr(10) & Chr(10)) & "Fehlerbeschreibung:" & (Chr(13) & Chr(10)) & Err.Description & (Chr(13) & Chr(10) & Chr(10)) &(Chr(13) & "berprfen Sie die Konfigution der Programme EchoLink und EchoLink+ und versuchen Sie es erneut." & Chr(10) & Chr(10) & Chr(10)) & "Das Programm wird nun beendet.", 10, sStation & Header, 16
		oEchoLink.Quit
		WScript.DisconnectObject(oEchoLink)
		Set oEchoLink = Nothing
		WScript.DisconnectObject(oWshShell)
		Set oWshShell = Nothing
		WScript.Quit(-1)
	End If


'	vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
'	###########################################################################
'	K O N F I G U R A T I O N
'	Wiederholtes "Freizeichen" und Systemmeldung nach Timeout bei Connectaufbau
'	!!! MUSS in Version 2.1.5 hier konfiguriert werden !!!
'	###########################################################################

'	AnnConnecting = 0	Wiederholtes "Freizeichen" und Systemmeldung nach TimeOut deaktiviert
'	AnnConnecting = 1	Wiederholtes "Freizeichen" deaktiviert; nur Systemmeldung nach Timeout, wenn RepeaterTX eingeschaltet
'	AnnConnecting = 2	"Freizeichen" und Systemmeldung nach Timeout werden immer ausgegeben - Repeater wird offen gehalten

	AnnConnecting = 2

'	^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^




'#########################################################################
'Initialisierungswerte     Diese Werte sollten NICHT veraendert werden !!!
'#########################################################################

	PopupMsg = ""
	sChar = ""
	sCharX = ""
	iCount = 0
	jCount = 0
	kCount = 0
	lCount = 0
	noDTMF = -1			' Schalter fuer kein DTMF-Ton empfangen
	TimerOn = -1			' Schalter fuer Timer-Status
	Link = -1			' Linkstatus
	EndOfScript = 0			' Scriptende
	CommandActive = 0		' Status des Commandinterpreters, verhindert mehrfache Ausfuehrung von Befehlen
	DTMFstringRec = 0		' DTMF-String wurde empfangen	

	SelCall = 0			' Initialisierungswert fuer Auswahl Ansagetext Rufzeichen
	PeersCount = 1			' Initialisierungswert fuer EchoLink Station connected
	RxOnCount = 1			' Initialisierungswert fuer Zaehler RxOn gesamt
	RxOnCountS = 1			' Initialisierungswert fuer Zaehler RxOn einzel
	LocalRxOnS = 0			' Schalter fuer Zaehler RxOn 
	LocalRxOn = 0			' Initialisierungswert fuer Zaehler (1 Step = 5 s) wenn RxOn > 5 s
	ValDisconn = 0			' Initialisierungswert fuer Ergebnis (Repeater-Rx / EchoLink-Rec)
	InfoEchoEnab = 0		' Initialisierungswert fuer Bedingung Ansagetext
	PrioLocTraff = 0		' Initialisierungswert fuer Lokalverkehr vorrang
	AnnBusyTime = 0			' Initialisierungswert fuer Zaehler der Busy-Zeit, zaehlt tAnnBusyTime runter auf 0
	TempBusyS = 0			' Schalter fuer temporaere Busy-Schaltung
	AnnBusyS = 0			' Schalter fuer Ansage Busy
	SuspLocOnly = 0			' Schalter fuer einmalige Busy-Schaltung
	AdverSwitchOff = 0		' Schalter fuer DTMF-Abschaltung
	AdverSwOffCount = 120		' Initialisierungswert fuer Zaehler DTMF-Dekoderabschaltung
	RecOn = 0			' Schalter fuer Empfang aus dem Internet
	RXOn = 0			' Schalter fuer Empfang vom Repeater
	RepeaterMode = 0		' Schalter fuer Gegenstation ist ein Repeater
	AgainConnect = 0		' Initialisierungswert fuer Zaehler zum Reconnect
	ELinkEnab = -1			' Schalter fuer Linkstatus
	ELinkEnabAkt = -1		' Initialisierungswert Aktueller Status EchoLink (Enabled)
	ELinkEnabTrigg = 0		' Schalter fuer Abschalten von Echolink
	RecOnCount = 1			' Initialisierungswert fuer Zaehler EchoLink Station sendet gesamt
	RecOnCountS = 1			' Initialisierungswert fuer Zaehler EchoLink Station sendet einzel
	RecOffCount = 1			' Initialisierungswert fuer Zaehler EchoLink Station sendet nicht
	PTTWDCount = 1			' Initialisierungswert fuer Zaehler PTT-Watchdog
	AskPreTraff = 0			' Initialisierungswert fuer Zaehler Ansageunterdrueckung wenn x sec vorher Betrieb
	AnnFree = -1			' Initialisierungswert fuer Ansagen freigegeben
	ClearToAnnDelay = 0		' Initialisierungswert fuer Ansage frei
	CallCount = 1			' Initialisierungswert fuer Aufrufzaehler Ansagen
	ClearToKillLink = 0		' Initialisierungswert fuer automat. Disconnect
	AutoDisc = 0			' Initialisierungswert fuer automat. Disconnect erfolgte
	DiscLink = 0			' Initialisierungswert fuer Disconnect #, ##
	ClearToReConnect = 1		' Initialisierungswert fuer Reconnectmoeglichkeit (DTMF "09")
	DiscEvent = 0			' Initialisierungswert fuer EchoLinkStation wurde disconnected
	RepHoldTimeCount = 0		' Initialisierungswert fuer Haltezeit Repeater (Verhinderung des Wiederauftastens, wenn abgefallen)
	OpenRep = 0			' Initialisierungswert fuer Repeater wurde geoeffnet
	SysopMode = 0			' Initialisierungswert fuer Sysop-Modus
	ClearPrivSub = -1		' Initialisierungswert fuer Behandlung PrivateSub
	sConnectingTo = ""		' Initialisierungswert DTMF-Nodenumber 
	DenyConn = 0			' Initialisierungswert NodeNumber/Call in Sperr-/Freigabeliste enthalten
	LenAnnStn = 0			' Initialisierungswert Laenge EchoLink-Station
	AnnStnCon = 0			' Initialisierungswert EchoLink-Station = Converence
	AnnStnLin = 0			' Initialisierungswert EchoLink-Station = Link
	AnnStnRep = 0			' Initialisierungswert EchoLink-Station = Repeater
	JustConnected = 0		' Initialisierungswert EchoLink-Station soeben connected
	ConnectingCall = 0		' Initialisierungswert EchoLink-Station selbst connected
	ConnectingTime = 0		' Initialisierungswert Beginn "ConnectedTo"
	ConnectingToNode = ""	' Initialisierungswert NodeNumber der zu connectenden Station
	CommandActiveTime = Int(Timer)
	WavFileTime = 0
	CallWavFileTime = 0
	CharToPlayTime = 0
	InfoEchoToPlayTime = 0
	CallToPlayTime = 0
	FileToPlayTime = 0
	StationOnline = 0
	StationBusy = 0
	bRX = 0
	DTMFstring = ""
	sDigits = ""
	DTMFCommand = ""
	Digits = ""
	FirstEcho = 0
	ListenOn = 0			' Initialisierungswert Listen-Modus
	CheckMaxPeers = 0		' Initialisierungswert MaxPeers
	ShortCut = 0
	ShortCutList = ""
	RxOrRec = 0			' Initialisierungswert Zeit fuer RepeaterRx oder EchoLinkStationReceived
	SLCount = 0			' Initialisierungswert Zaehler Transfer EchoLink-Stationsliste von EchoLink in TempTabelle
	SearchCount = 0			' Initialisierungswert Zaehler Transfer EchoLink-Stationsliste TempTabelle in Tabelle
	BreakTime = 0			' Initialisierungswert Unterbrechung Transferprozess EchoLink-Stationsliste
	TransferStatList = 0		' Initialisierungswert fuer Transferprozess EchoLink-Stationsliste
	StationListRec = 0		' Initialisierungswert EchoLink-StationList erneuert
	StationConnected = 0		' Initialisierungswert EchoLink-Station connected
	AnnTimeEnab = 0			' Start Stundensignal scharf geschaltet
	sStationStatus = "ON"		' Initialisierungswert Status eigene Station
	doneAnnCall = 0			' Initialisierungswert fr AnsageCall ausgefuehrt
	doneTimeSignal = 0		' Initialisierungswert fr Zeitzeichen ausgefuehrt
	doneAnnTime = 0			' Initialisierungswert fr Zeitansage ausgefuehrt
	doneAnnActMsg = 0		' Initialisierungswert fr Aktuelle Mitteilung ausgefuehrt
	RefreshInterval = 10		' Initialisierungswert Intervall Aktualisierung EchoLink-Stationsliste
	ClsELP = 0			' Initialisierungswert fuer Shutdown Script
	CloseELPCount = 4		' Initialisierungswert fuer Shutdown Script

	If (AnnActMsg = 0) Then
		AnnActMsgSysOp = 0	' Initialisierungswert fr Sysop-Kommando " Ausgabe Aktuelle Mitteilung AUSgeschaltet"
	Else
		AnnActMsgSysOp = -1	 'Initialisierungswert fr Sysop-Kommando " Ausgabe Aktuelle Mitteilung EINgeschaltet"
	End If

	ConfEchoLink.LocationFree = sLinkFree	' Anzeige in Stationsliste wenn "free"
	ConfEchoLink.Apply 0


' ##################################################################################
' Start der Schleifen
' ##################################################################################

	BreakTime = 0

	While Not EndOfScript				' MainLoop
		Do While ((Timer - BreakTime) <= 0.5)
			If (BreakTime > Timer) Then
				Exit Do
			End If
			WScript.Sleep 50
		Loop

		BreakTime = Timer

		If AutoUpdateELP AND StationListRec AND (RefreshInterval <= (RefreshIntervalELP - 3))  AND (TransferStatList = 0) AND Not AnnTimeEnab Then
			Set oStations = oEchoLink.StationEntries
			SLCount = 0
			TransferStatList = 1
		End If

		If AutoUpdateELP AND StationListRec AND (TransferStatList = 1) AND (Timer < 86370) Then
			For Each oStation In oStations
				If ((Timer - BreakTime) <= 0.49) Then
					tStationList(SLCount, 0) = oStation.Callsign
					tStationList(SLCount, 1) = oStation.NodeNumber
					tStationList(SLCount, 2) = oStation.Status
					SLCount = (SLCount + 1)
				Else
					MainSub
				End If
			Next
			TransferStatList = 2
			StationListRec = 0
			For SLCount = 0 To 6000
				aStationList(SLCount, 0) = tStationList(SLCount, 0)
				tStationList(SLCount, 0) = ""
				aStationList(SLCount, 1) = CStr(tStationList(SLCount, 1))
				tStationList(SLCount, 1) = ""
				aStationList(SLCount, 2) = tStationList(SLCount, 2)
				tStationList(SLCount, 2) = ""
			Next				
		Else
			MainSub
		End If
	Wend


ShutdownEchoLink



' ##################################################################################
'	Bereich der Unterprogramme
' ##################################################################################



Sub MainSub

	Err.Clear
' #########################
' Sysop-Modus zuruecksetzen
' #########################

	ResetTime = Mid(Time,4,2) - 1			'Nach 1 Minute Sysop-Modus ausschalten
	If SysopMode AND (ResetTime = SysopTime) Then
		SysopMode = 0
		FileToPlay = WavInfoEchoDir & "SysopOff.wav"
		FileName = FileToPlay
		GetWavFileTime(FileName)
		FileToPlayTime = WavFileTime
		PTTOnDelay
		oEchoLink.SendID 3, FileToPlay
		Err.Clear
		WScript.sleep (FileToPlayTime)
		PTTOff
	End If



' ################################################################################################
' Bedingungen pruefen, SUBs abarbeiten, Ausgabe der Texte und Zeitzeichen, Link an- und abschalten
' ################################################################################################


	If (FirstEcho <> 0) AND (ActSec = 25) Then	' Ruecksetzung detaillierte Ansage DTMF-Quittungen
		FirstEcho = (FirstEcho - 0.5)
		If FirstEcho < 2 Then
			FirstEcho = 0
		End If
	End If

	ChkStatusRxPTT
	Watchdog

	If (DTMFstringRec = 1) Then
		DTMFstringRec = 2
		DTMFstringReceived
	End If

	If (DTMFstringRec = 3) Then
		DTMFSub
	End If
	
	If ((Int(Timer) - CommandActiveTime) > 5) Then
		DTMFstringRec = 0
	End If

	If ((Int(Timer) - CommandActiveTime) > 15) Then	' Sperrt fr 15 s gleichen DTMF-Befehl
		Digits = ""
	ElseIf (Int(Timer) < CommandActiveTime) Then
		CommandActiveTime = Int(Timer)
	End If		

	AutoDisconnect
	DisconnectLink

	If JustConnected Then
		If (RepHoldTimeCount < (tRepHoldTime + tRepPostTime)) Then
			AnnConnected
		End If
		JustConnected = 0
	End If

	If ConnectingCall AND (AnnConnecting <> 0) Then
		If (sStationMode = "-L") AND ((Timer - ConnectingTime) < (bTimeoutTrying + 7)) AND (RepHoldTimeCount >= 7) AND (RepHoldTimeCount <= 8) Then
			SystemLog
			If ConnectingCall Then
				DTMFCommand = "*ConnectingS"
				PlayInfoEchoMisc
				DTMFCommand = ""
				RepHoldTimeCount = 0
			End If
		ElseIf (AnnConnecting = 2) AND (sStationMode = "-R") AND ((Timer - ConnectingTime) < (bTimeoutTrying + tRepHoldTime)) AND (RepHoldTimeCount >= (tRepHoldTime - 2)) AND (RepHoldTimeCount <= tRepHoldTime) Then
			SystemLog
			If ConnectingCall Then
				DTMFCommand = "*ConnectingS"
				PlayInfoEchoMisc
				DTMFCommand = ""
				RepHoldTimeCount = 0
			End If
		ElseIf (AnnConnecting = 1) AND (sStationMode = "-R") AND ((Timer - ConnectingTime) >= (bTimeoutTrying + 7)) Then
			SystemLog
			ConnectingCall = 0
			DTMFCommand = ""
		End If
		If ConnectingCall AND (sStationMode = "-R") AND ((Timer - ConnectingTime) > (bTimeoutTrying + tRepHoldTime + 7)) Then
			ConnectingCall = 0
			DTMFCommand = ""
		ElseIf ConnectingCall AND (sStationMode = "-L") AND ((Timer - ConnectingTime) > (bTimeoutTrying + 12)) Then
			ConnectingCall = 0
			DTMFCommand = ""
		End If
	End If

	If (TransferStatList = 2) Then
		StationListReceivd
		TransferStatList = 0
		StationListRec = 0
	End If

	If StationConnected Then
		StnConnected
		ChkMaxPeers
	End If

	If ELinkEnabTrigg Then
		EchoLinkEnableDisable
	End If

	ActDay = Weekday(Now)
	ActHour = Hour(Now)
	ActMin = Minute(Now)
	ActSec = Second(Now)

	If SuspTemp AND (ActMin = 0) AND (ActSec >= 15) AND (ActSec <= 20) Then
		If (tSuspTempOff > tSuspTempOn) Then
			If (ActHour < tSuspTempOff) AND (ActHour >= tSuspTempOn) Then		' EchoLink enabled
				ELinkEnab = -1
			Else
				ELinkEnab = 0
			End If
		ElseIf (tSuspTempOff < tSuspTempOn) Then
			If (ActHour >= tSuspTempOff) AND (ActHour < tSuspTempOn) Then		' EchoLink disabled
				ELinkEnab = 0
			Else
				ELinkEnab = -1
			End If
		End If
		If ELinkEnab <> ELinkEnabAkt Then 
			ELinkEnabTrigg = -1
		End If
	End If

	If InfoEcho = 2 Then
		If (tInfoEchoOn > tInfoEchoOff) Then
			If (ActHour < tInfoEchoOn) AND (ActHour >= tInfoEchoOff) Then		' Informations-Ansagen freigeben / sperren
				InfoEchoEnab = 0
			Else
				InfoEchoEnab = -1
			End If
		ElseIf (tInfoEchoOn < tInfoEchoOff) Then
			If (ActHour >= tInfoEchoOn) AND (ActHour < tInfoEchoOff) Then		' Informations-Ansagen freigeben / sperren
				InfoEchoEnab = -1
			Else
				InfoEchoEnab = 0
			End If
		End If
	ElseIf InfoEcho = 1 Then
		InfoEchoEnab = -1
	ElseIf InfoEcho = 0 Then
		InfoEchoEnab = 0
	End If

	If SuspLocalOnly Then
		SuspendLocalOnly
	End If

	If PriorLocalTraff AND Not SuspLocOnly Then
		PrioLocalTraff
	End If

	If AnnBusyTime <> 0 Then
		AnnBusyTime = (AnnBusyTime - 0.5)
	End If
			
	If GuardAutoDiscAgain AND (AgainConnect <> 0) Then
		 AgainConnect = (AgainConnect - 0.5)
		If (AgainConnect > 305) OR TempBusyS Then
			TempBusy
		End If
	End If

	If Not OpenRep AND AnnIfNotTraff AND (AskPreTraff <> 0) Then
		AskPreTraff = (AskPreTraff - 0.5)
		If AskPreTraff > 1 Then
			AnnFree = 0
		Else
			AnnFree = -1
		End If
	End If

	If CallCount < 1 Then
		CallCount = 1
	ElseIf CallCount > 1 Then
		CallCount = (CallCount - 1)
	End If

	If (CloseELPCount > 1) Then
		CloseELPCount = (CloseELPCount - 0.5)
	ElseIf (CloseELPCount = 1) Then
		CheckShutdown
		If ClsELP Then
			ShutdownEchoLinkPlus
		End If
	End If

	If (RefreshInterval > 1) Then
		RefreshInterval = (RefreshInterval - 0.5)
	End If

	If (RefreshInterval = 1) Then
		RefreshStnList
	End If

	If AnnounceHour AND (ELinkEnab OR AnnIfNotEnabEL) Then
		If ClearToAnn OR OpenRep Then
			If ((ActMin = 59) OR (ActMin = 29)) Then
				If (ActSec >= 15) AND (ActSec <= 20) AND Not AnnTimeEnab Then
					AnnBegin
				End If
				If AnnTimeEnab Then
					If AnnFree AND Not OpenRep AND (ActSec >= tPreOpenRepSI) AND (ActSec <= (tPreOpenRepSI + 3)) Then
						If (PreOpenRepeater <> 0) Then
							PreOpenRep
							OpenRep = -1
						ElseIf (PreOpenRepeater = 0) Then
							OpenRep = -1
						End If
					End If

					If Not doneAnnCall AND OpenRep AND (AnnFree OR Not AnnIfNotRxOn) AND (ActSec >= tAnnCall) AND (ActSec <= (tAnnCall + 2)) AND (((ActMin = 59) AND (AnnCall <> 0)) OR ((ActMin = 29) AND ((AnnCall = 2)))) Then
						pAnnStn
					End If

					If doneAnnCall AND (AnnTimeSig = 0) AND (AnnTime = 0) AND (AnnActMsg = 0) Then
						PTTOff
						AnnTimeEnab = 0
						OpenRep = 0
					ElseIf (AnnTimeSig = 0) Then
						PTTOff
					End If
				End If

                If Not doneTimeSignal AND OpenRep AND (AnnFree OR Not AnnIfNotRxOn) AND ((ActSec >= 53) AND (ActSec <= 55)) AND (((ActMin = 59) AND (AnnTimeSig <> 0)) OR ((ActMin = 29) AND ((AnnTimeSig = 2))))Then
					pTimeSignal
					If AnnIfNotRxOn AND (Not AnnFree OR (AnnTime = 0)) Then
						PTTOff
						AnnTimeEnab = 0
						OpenRep = 0
					End If
				End If						
			End If

			If ((ActMin = 0) OR (ActMin = 30)) Then
				If Not doneAnnTime AND OpenRep AND (AnnFree OR Not AnnIfNotRxOn) AND (ActSec => 1) AND (ActSec =< 3) AND (((ActMin = 0) AND (AnnTime <> 0)) OR ((ActMin = 30) AND ((AnnTime = 2)))) Then
					pAnnTime
					PTTOff
					If AnnIfNotRxOn AND (Not AnnFree OR (AnnActMsg = 0)) Then
						AnnTimeEnab = 0
						OpenRep = 0
					End If
				Else
					PTTOff
				End If
				If Not doneAnnActMsg AND OpenRep AND (ActSec >= 8) AND (ActSec <= 10) AND (((ActMin = 0) AND (AnnActMsg <> 0)) OR ((ActMin = 30) AND ((AnnActMsg = 2)))) Then
						pAnnActMsg
						PTTOff
					AnnTimeEnab = 0
					OpenRep = 0
				End If						
			End If
		End If
	End If

	If StationListRec Then
		BreakTime = Timer
	End If

End Sub




'	################
'	Shutdown pruefen
'	################

Sub CheckShutdown
	Err.Clear
	Set oWshShell = WScript.CreateObject("WScript.Shell")
	CloseELP = oWshShell.RegRead(RegKeyELP & "CloseELP")
	If CloseELP Then
		ClsELP = -1
		CloseELP = 0
		oWshShell.RegWrite RegKeyELP & "CloseELP", CloseELP, "REG_SZ"
	End If
	CloseELPCount = 3
	WScript.DisconnectObject(oWshShell)
	Set oWshShell = Nothing
End Sub



'	####################
'	EchoLinkPlus beenden
'	####################

Sub ShutdownEchoLinkPlus
	WScript.DisconnectObject(oEchoLink)
	Set oEchoLink = Nothing
	WScript.Quit
End Sub



'	################
'	EchoLink beenden
'	################

Sub ShutdownEchoLink
	oEchoLink.Quit
	WScript.DisconnectObject(oEchoLink)
	Set oEchoLink = Nothing
	WScript.Quit
End Sub




'	#########################
'	EchoLink.exe wird beendet
'	#########################

Sub EchoLink_Closing()
	WScript.DisconnectObject(oEchoLink)
	Set oEchoLink = Nothing
	WScript.Quit
End Sub



'	###########################
'	DTMF String wurde empfangen
'	###########################

Sub EchoLink_DTMFstring(DTMFstring)
	If DTMFstringRec = 0 Then
		sDigits = DTMFstring
		DTMFstringRec = 1
	End If
End Sub	


Sub DTMFstringReceived
	If  (TempBusyS OR SuspLocOnly OR (PrioLocTraff = 1) OR Not ELinkEnab) AND Not SysopMode AND (sDigits <> Password) AND (sDigits <> DispBusy) Then
		If (DTMFstringRec = 2) AND (sDigits <> Digits) AND ClearPrivSub Then
			Digits = sDigits
			CommandActiveTime = Int(Timer)
			DTMFCommand = "*LocalBusy"			' Ansage 'Nur Localbetrieb'
			PlayInfoEchoMisc
			DTMFstringRec = 3
		End If
		Exit Sub
	End If
	If (DTMFstringRec = 2) AND (sDigits <> Digits) AND ClearPrivSub Then
		If Not CommandActive Then
			Digits = sDigits				' zuletzt empfangener DTMF-String
			CommandActiveTime = Int(Timer)
			If PreCmdDTMF Then
				If (Len(sDigits) > 3) AND (Left(sDigits,1) <> PreCmdChar) AND (Left(sDigits,2) <> "04") Then
					DTMFCommand = "*11"
				Else
					DTMFCommand = sDigits
				End If
			Else
				DTMFCommand = sDigits
			End If
			If ErrorCheck Then 
				If (Len(sDigits) < 4) AND (Left(sDigits,1) <> "*") AND (Left(sDigits,1) <> "#") AND (Left(sDigits,1) <> "0") AND (Left(sDigits,1) <> "D") AND (Left(sDigits,2) <> "B#") Then
					DTMFCommand = "*Error"
				ElseIf (Len(sDigits) > 6) AND (sDigits <> Password) AND (Left(sDigits,2) <> "06") AND (Left(sDigits,2) <> "07") AND (Left(sDigits,1) <> "C") Then
					DTMFCommand = "*Error"
				Else
					DTMFCommand = sDigits
				End If
			Else
				DTMFCommand = sDigits
			End If
			If QuickConnect AND (Len(sDigits) > 3) AND (Len(sDigits) < 7) AND (Left(sDigits,1) <> "A") Then
				If (Left(sDigits,1) <> "*") AND (Left(sDigits,1) <> "#") AND (Left(sDigits,1) <> "0") AND (Left(sDigits,1) <> "B") AND (Left(sDigits,1) <> "C") AND (Left(sDigits,1) <> "D") Then
					If (oEchoLink.NumPeers = MaxPeers) Then	' Ueberpruefung, ob Connect moeglich
						DTMFCommand = "*StillConnected"
					Else 
						sConnectingTo = sDigits
						DTMFCommand = "*ConnectingTo"
					End If
				End If
			ElseIf QuickConnect AND (Len(sDigits) > 4) AND (Len(sDigits) < 8) AND (Left(sDigits,1) = "A") Then
				If (Left(sDigits,1) <> "*") AND (Left(sDigits,1) <> "#") AND (Left(sDigits,1) <> "0") AND (Left(sDigits,1) <> "B") AND (Left(sDigits,1) <> "C") AND (Left(sDigits,1) <> "D") Then
					If (oEchoLink.NumPeers = MaxPeers) Then	' Ueberpruefung, ob Connect moeglich
						DTMFCommand = "*StillConnected"	
					Else 
						sConnectingTo = sDigits
						DTMFCommand = "*ConnectingTo"
					End If
				End If
			ElseIf QuickConnect AND (Len(sDigits) = 3) Then		' Kurzwahl aufrufen
				If (oEchoLink.NumPeers = MaxPeers) Then		' Ueberpruefung, ob Connect moeglich
					DTMFCommand = "*StillConnected"
				Else
					ShortNumber
				End If
			End If
		Else
			DTMFCommand = "*Error"
		End If

		If (DTMFCommand = "*Error") OR (DTMFCommand = "*StillConnected") Then
			If (CallCount > 600) AND GuardCallCount Then	' gegen den "Spieltrieb"
				CallCount = (CallCount +100)
				If (CallCount > 1800) Then			' Begrenzung auf 15 Minuten Sperrzeit
					CallCount = 1800
				End If
				DTMFCommand = ""
			End If
			CallCount = (CallCount + 10)
		End If
		Err.Clear
		DTMFstringRec = 3
	End If
	If  Not SuspLocOnly AND (PrioLocTraff <> 1) AND ELinkEnab Then		' Bedingung, um Ruecksetzung LocalRxOn zu verhindern, wenn LokalBusy
		LocalRxOn = 0
	End If
End Sub





' #######################################
' DTMF-Toene auswerten und Texte ausgeben
' #######################################

Sub DTMFSub
		CommandActive = -1
		Select Case DTMFCommand
		Case "*ConnectingTo"
			ConnectStation
		Case "#"
			DiscLink = 1
		Case "##"
			DiscLink = 2
		Case "*"
			StationInfo
		Case "**"
			ActTimeAnn
		Case "*#"
			NodeInfo
		Case DispInactTimeout
			ListenMode
		Case sStatusELP
			ConnectStatus
		Case sReconnectELP
			ReconnectStation
		Case "*0"
			PlayInfoEcho
		Case "*1"
			PlayInfoEcho
		Case "*2"
			PlayInfoEcho
		Case "*3"
			PlayInfoEcho
		Case "*4"
			PlayInfoEcho
		Case "*5"
			PlayInfoEcho
		Case "*6"
			PlayInfoEcho		
		Case "*7"
			PlayInfoEcho
		Case "*8"
			PlayInfoEcho
		Case "*9"
			PlayInfoEcho
		Case "*11"
			PlayInfoEcho
		Case "*Error"
			PlayInfoEchoMisc
		Case "*StillConnected"
			PlayInfoEchoMisc
		Case Password
			SysopAccess
		Case DispBusy
			DispenseBusy
		Case "0#00"		' Link abschalten
			If SysopMode Then
				DTMFCommand = "*LinkOff"
				PlayInfoEchoMisc
				Link = 0
				ELinkEnab = 0
				oEchoLink.EnableLink 0
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#01"		' Link anschalten 
			If SysopMode Then
				Link = -1
				ELinkEnab = -1
				oEchoLink.EnableLink -1
				DTMFCommand = "*LinkOn"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#10"		' drei Timer auf 0 setzen, um Verbindungen aufrecht zu erhalten
			If TimerOn AND Not ListenOn AND SysopMode Then
				TimerOn = 0
				ConfEchoLink.TimeoutReceiveLimit = 0
				ConfEchoLink.TimeoutTransmitLimit = 0
				ConfEchoLink.TimeoutInactivity = 0
				ConfEchoLink.Apply 0
				DTMFCommand = "*TimerOff"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#11"		' Timer auf Default-Werte zuruecksetzen
		 	If Not TimerOn AND Not ListenOn AND SysopMode Then
				TimerOn = -1
				ConfEchoLink.TimeoutReceiveLimit = bReceivetimeout
				ConfEchoLink.TimeoutTransmitLimit = bTransmitTimeout
				ConfEchoLink.TimeoutInactivity = bInactivityTimeout
				ConfEchoLink.Apply 0
				DTMFCommand = "*TimerOn"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#20"		' Schaltet die Ansagen und Mitteilung aus 
			If SysopMode Then
				DTMFCommand = "*CallOff"
				PlayInfoEchoMisc
				Announcements = 0
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#21"		' Schaltet die Ansagen ein
			If SysopMode Then
				Announcements = -1
				DTMFCommand = "*CallOn"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#22"		' Schaltet Aktuelle Mitteilung aus
			If SysopMode Then
				AnnActMsgSysOp = 0
				DTMFCommand = "*MsgOff"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#23"		' Schaltet Aktuelle Mitteilung ein
			If SysopMode Then
				AnnActMsgSysOp = -1
				DTMFCommand = "*MsgOn"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#30"		' Setzt die "Nachtabschaltung" von EchoLink ausser Betrieb
			If SysopMode Then
				SuspTemp = 0
				DTMFCommand = "*SuspTempOff"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#31"		' Schaltet die "Nachtabschaltung" von EchoLink ein - gem. Konfigurierung
			If SysopMode Then
				SuspTemp = -1
				DTMFCommand = "*SuspTempOn"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#40"		' Setzt die temporaere Abschaltung (fuer Rundsprueche, etc.) von EchoLink (Busy) ausser Betrieb
			If SysopMode Then
				SuspLocalOnly = 0
				DTMFCommand = "*SuspLocalOff"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#41"		' Schaltet die temporaere Abschaltung (fuer Rundsprueche, etc.) von EchoLink (Busy) ein
			If SysopMode Then
				SuspLocalOnly = -1
				DTMFCommand = "*SuspLocalOn"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#50"		' Setzt die Prioritaet fuer Localbetrieb (EchoLink Busy und DTMF gesperrt) ausser Betrieb
			If SysopMode Then
				PriorLocalTraff = 0
				DTMFCommand = "*PriorLocalOff"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#51"		' Schaltet die Prioritaet fuer Localbetrieb (EchoLink Busy und DTMF gesperrt) ein
			If SysopMode Then
				PriorLocalTraff = -1
				DTMFCommand = "*PriorLocalOn"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0#99" 		' Script beenden
			If SysopMode Then
				DTMFCommand = "*Over"
				PlayInfoEchoMisc
				EndOfScript = -1
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0###" 		' Script sofort beenden
			If SysopMode Then
				EndOfScript = -1		
			End If
		Case "0#**"	' Modus ansagen
			If SysopMode Then
				If Link Then
					DTMFCommand = "*LinkOn"
					PlayInfoEchoMisc
				End If
				If Not Link Then
					DTMFCommand = "*LinkOff"
					PlayInfoEchoMisc
				End If
				If TimerOn Then
					DTMFCommand = "*TimerOn"
					PlayInfoEchoMisc
				End If
				If Not TimerOn Then
					DTMFCommand = "*TimerOff"
					PlayInfoEchoMisc
				End If
				If Announcements Then
					DTMFCommand = "*CallOn"
					PlayInfoEchoMisc
				End If
				If Not Announcements Then
					DTMFCommand = "*CallOff"
					PlayInfoEchoMisc
				End If
				If AnnActMsgSysOp Then
					DTMFCommand = "*MsgOn"
					PlayInfoEchoMisc
				End If
				If Not AnnActMsgSysOp Then
					DTMFCommand = "*MsgOff"
					PlayInfoEchoMisc
				End If
				If SuspTemp Then
					DTMFCommand = "*SuspTempOn"
					PlayInfoEchoMisc
				End If
				If Not SuspTemp Then
					DTMFCommand = "*SuspTempOff"
					PlayInfoEchoMisc
				End If
				If SuspLocalOnly Then
					DTMFCommand = "*SuspLocalOn"
					PlayInfoEchoMisc
				End If
				If Not SuspLocalOnly Then
					DTMFCommand = "*SuspLocalOff"
					PlayInfoEchoMisc
				End If
				If PriorLocalTraff Then
					DTMFCommand = "*PriorLocalOn"
					PlayInfoEchoMisc
				End If
				If Not PriorLocalTraff Then
					DTMFCommand = "*PriorLocalOff"
					PlayInfoEchoMisc
				End If
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		Case "0##0"
			If SysopMode Then
				LoadConfig
				oEchoLink.Reset
				WScript.Sleep 1000
				ClearPrivSub = -1
				PTTWDCount = 1
				DTMFCommand = "*Beep"
				PlayInfoEchoMisc
			Else
				DTMFCommand = "*False"
				PlayInfoEchoMisc
			End If
		End Select
		If Not EndOfScript Then
			CommandActive = 0
			DTMFCommand = ""
			Err.Clear
		End If
End Sub




'	#####################################
'	Connect Station - DTMF Case [Connect]
'	#####################################

Sub ConnectStation
	If ConnectingCall Then
		Exit Sub
	End If
	DenyConn = InStr(1, (BannedCallsign & ","), ("," & sConnectingTo & ","))
	If ((DenyConn = 0) AND (CallsignDeny = 1)) OR ((DenyConn <> 0) AND (CallsignDeny <> 1)) Then
		IsStationOnlineOrBusy
		If Not StationOnline AND Not StationBusy Then
			DTMFCommand = "*NotFound"
			PlayInfoEchoMisc
		ElseIf Not StationOnline AND StationBusy Then
			DTMFCommand = "*StationBusy"
			PlayInfoEchoMisc
		ElseIf StationOnline AND Not StationBusy AND Not oEchoLink.RXSignal Then
			If	bCallIfELBusy AND (MaxPeers = 1) Then
				ConfEchoLink.LocationBusy = sEchoLinkBusyCall & ConnectingTo	' Anzeige in EchoLink-Stationsliste (mit connecteter Station) wenn "Busy" eine Station zugelassen
				ConfEchoLink.Apply 0
			Else
				ConfEchoLink.LocationBusy = sEchoLinkBusy			' Anzeige in EchoLink-Stationsliste wenn "Busy" durch x EchoLink-Stationen
				ConfEchoLink.Apply 0
			End If
			ConnectingTime = Timer
			DTMFCommand = "*Connecting"
			PlayInfoEchoMisc
 			oEchoLink.Connect ConnectingToNode, 0	' NodeNumber der zu connectenden Station
			ConnectingCall = -1
		End If
	Else
		DTMFCommand = "*Deny"								' Station ist gesperrt (Deny ...)
		PlayInfoEchoMisc
	End If
	Err.Clear
End Sub



'	##################
'	Daten in SystemLog
'	##################

Sub SystemLog
	If oEchoLink.RXSignal OR oEchoLink.Receiving Then
		Exit Sub
	End If
	Set FileSO = CreateObject("Scripting.FileSystemObject")
	Set FileN = FileSO.OpenTextFile(PathEchoLink &"\QSOLog.txt", 1)
	Do While FileN.AtEndOfStream <> -1
		ReadLine = FileN.ReadLine
	Loop
	FileN.Close
	WScript.DisconnectObject(FileSO)
	Set FileSO = Nothing
	If (((Mid(ReadLine, 12, 2) * 3600) + (Mid(ReadLine, 15, 2) * 60) + Mid(ReadLine, 18, 2)) > ConnectingTime) AND (InStr(1, ReadLine, "ConnectAttemptFailed", 1) <> 0) Then
		AnnStn = ConnectingTo
		AnnounceStation
		If (InStr(1, ReadLine, "Access denied", 1) <> 0) Then
			DTMFCommand = "*Denied"
			PlayInfoEchoMisc
			ConnectingCall = 0
		ElseIf (InStr(1, ReadLine, "Busy", 1) <> 0) Then
			DTMFCommand = "*StationBusy"
			PlayInfoEchoMisc
			ConnectingCall = 0
		ElseIf (InStr(1, ReadLine, "Timed out", 1) <> 0) Then	' Signalisierung NotFound nach Timeout
			DTMFCommand = "*NotFound"
			PlayInfoEchoMisc
			ConnectingCall = 0
		End If
	End If
End Sub



'	#######################################
'	Zu connectende Station Online oder Busy
'	#######################################

Sub IsStationOnlineOrBusy
		StationOnline = 0
		StationBusy = 0
		SearchCount = 0
		For SearchCount = 0 To 6000
			If (aStationList(SearchCount, 0) = sConnectingTo) OR (aStationList(SearchCount, 1) = sConnectingTo) Then
				ConnectingTo = aStationList(SearchCount, 0)
				ConnectingToNode = aStationList(SearchCount, 1)
				If aStationList(SearchCount, 2) = "ON" Then
					StationOnline = -1
				ElseIf aStationList(SearchCount, 2) = "BUSY" Then
					StationBusy = -1
				End If
				Exit For
			End If
		Next
End Sub



'	################################
'	Signalisierung Station Connected
'	################################

Sub AnnConnected

	If Not SysAnnELPlus Then
		Exit Sub
	End If
	WScript.Sleep 800
	If Not oEchoLink.RXSignal AND Not oEchoLink.Receiving AND (RepHoldTimeCount < tRepHoldTime) Then
		If ConnectingCall Then
			InfoEchoToPlay = WavInfoEchoDir & "ActConn.wav"
		Else
			InfoEchoToPlay = WavInfoEchoDir & "AC.wav"
		End If
		FileName = InfoEchoToPlay
		GetWavFileTime(FileName)
		InfoEchoToPlayTime = WavFileTime
		PTTOnDelay		
		oEchoLink.SendID 3, InfoEchoToPlay
		Err.Clear
		WScript.Sleep InfoEchoToPlayTime
		AnnStn = ActConnect
		AnnounceStation
		PTTOff
	End If
	DTMFCommand = ""
	ConnectingCall = 0
	Err.Clear
End Sub



'	########################
'	Kurzwahlnummern zuordnen
'	########################

Sub ShortNumber
	IsShortCut(Digits)
	If ShortCut Then
		DTMFCommand = "*ConnectingTo"
	Else
		sConnectingTo = ""
		DTMFCommand = "*Error"
	End If
End Sub



'	#############################
'	Sysop-Zugang mittels Passwort
'	#############################

Sub SysopAccess
	SysopMode = -1
	SysopTime = Mid(Time,4,2) + 1
	FileToPlay = WavInfoEchoDir & "SysopOn.wav"
	FileName = FileToPlay
	GetWavFileTime(FileName)
	FileToPlayTime = WavFileTime
	PTTOnDelay
	oEchoLink.SendID 3, FileToPlay
	Err.Clear
	WScript.sleep (FileToPlayTime)
	PTTOff
End Sub



'	###############################################
'	Deaktivierung EchoLink Busy bei lokalem Betrieb
'	###############################################

Sub DispenseBusy
	If (PrioLocTraff = 1) Then
		WScript.Sleep 2000
		If Not oEchoLink.RXSignal Then
			ConfEchoLink.LocationBusy = sEchoLinkBusy		' Anzeige in Stationsliste wenn "Busy" ActConnect
			ConfEchoLink.Apply 0
			oEchoLink.ListAsBusy = 0				' Eigene Station ist "On"
			FileToPlay = WavInfoEchoDir & "DispBusy.wav"
			FileName = FileToPlay
			GetWavFileTime(FileName)
			FileToPlayTime = WavFileTime
			PTTOnDelay
			oEchoLink.SendID 3, FileToPlay
			Err.Clear
			WScript.sleep (FileToPlayTime)
			PTTOff
			PrioLocTraff = 2
			RefreshInterval = 5
		End If
	End If
End Sub



'	#############################################
'	ListenMode zur Abschaltung Inactivity-Timeout
'	#############################################

Sub ListenMode

	If Not ListenOn Then
		ListenOn = -1
		ConfEchoLink.TimeoutInactivity = 0
		ConfEchoLink.Apply 0
		DTMFCommand = "*ListenOn"
		PlayInfoEchoMisc
	ElseIf ListenOn Then
		ListenOn = 0
		ConfEchoLink.TimeoutInactivity = bInactivityTimeout
		ConfEchoLink.Apply 0
		DTMFCommand = "*ListenOff"
		PlayInfoEchoMisc
	End If
End Sub


'	######################################
'	Ausgabe ConnectStatus - DTMF Case [08]
'	######################################

Sub ConnectStatus
	If Not SysAnnELPlus Then
		Exit Sub
	End If
	If (oEchoLink.NumPeers = 0) AND ELinkEnab Then 
		If ClearToReConnect > 10 Then					' Zeit [s] die noch zum Reconnect zur Verfuegung steht
    		InfoEchoToPlay = WavInfoEchoDir & "LastConn.wav"		' Ausgabe "Nicht verbunden - letzte Verbindung..."
			FileName = InfoEchoToPlay
			GetWavFileTime(FileName)
			InfoEchoToPlayTime = WavFileTime
			If Not oEchoLink.RXSignal AND Not oEchoLink.Receiving Then
				PTTOnDelay
				oEchoLink.SendID 3, InfoEchoToPlay
				Err.Clear
				WScript.Sleep InfoEchoToPlayTime        
				AnnStn = LastConnect
				AnnounceStation
				PTTOff
			End If
		Else
			InfoEchoToPlay = WavInfoEchoDir & "NotConn.wav"		' Ausgabe "Nicht verbunden ..."
			FileName = InfoEchoToPlay
			GetWavFileTime(FileName)
			InfoEchoToPlayTime = WavFileTime
			If Not oEchoLink.RXSignal AND Not oEchoLink.Receiving Then
				PTTOnDelay
				oEchoLink.SendID 3, InfoEchoToPlay
				Err.Clear 
				WScript.Sleep InfoEchoToPlayTime
				PTTOff
			End If
		End If
	ElseIf (oEchoLink.NumPeers <> 0) AND ELinkEnab Then
		InfoEchoToPlay = WavInfoEchoDir & "ActConn.wav"
		FileName = InfoEchoToPlay
		GetWavFileTime(FileName)
		InfoEchoToPlayTime = WavFileTime
		If Not oEchoLink.RXSignal AND Not oEchoLink.Receiving Then
			PTTOnDelay
			oEchoLink.SendID 3, InfoEchoToPlay			' Ausgabe "Verbunden mit ..."
			Err.Clear
			WScript.Sleep InfoEchoToPlayTime
			AnnStn = ActConnect
			AnnounceStation						' Rufzeichen der aktuell connecteten Station ausgeben
			PTTOff
		End If
	End If
	DTMFCommand = ""
	Err.Clear
End Sub



'	##################################
'	Ansage Rufzeichen EchoLink-Station
'	##################################

Sub AnnounceStation
	If Not SysAnnELPlus OR oEchoLink.RXSignal OR oEchoLink.Receiving Then
		Exit Sub
	End If
	LenAnnStn = Len(AnnStn)
	AnnStnCon = 0
	AnnStnLin = 0
	AnnStnRep = 0
	If (Left(AnnStn, 1) = "*") Then
		AnnStnCon = -1
		LenAnnStn = (LenAnnStn - 2)
		AnnStn = Mid(AnnStn, 2, LenAnnStn)
	ElseIf (Right(AnnStn, 2) = "-L") Then
		AnnStnLin = -1
		LenAnnStn = (LenAnnStn - 2)
		AnnStn = Mid(AnnStn, 1, LenAnnStn)
	ElseIf (Right(AnnStn, 2) = "-R") Then
		AnnStnRep = -1
		LenAnnStn = (LenAnnStn - 2)
		AnnStn = Mid(AnnStn, 1, LenAnnStn)
	End If

	If (SelAnnMaleFemale = 0) Then
		Randomize Timer
		ATV = Int((2 * Rnd) + 1)
		If (ATV = 1) Then 
			ATVoice = "M"
		Else
			ATVoice = "F"
		End If
	ElseIf (SelAnnMaleFemale = 1) Then
		ATVoice = "M"
	ElseIf (SelAnnMaleFemale = 2) Then
		ATVoice = "F"
	End If
	
	For kCount = 1 To LenAnnStn
		If kCount = LenAnnStn AND Not AnnStnCon AND Not AnnStnLin AND Not AnnStnRep Then
			CharToPlay = WavCallDir & ATVoice & Mid(AnnStn, kCount, 1) & "e.wav"
			FileName = CharToPlay
			GetWavFileTime(FileName)
			CharToPlayTime = WavFileTime
		Else
			CharToPlay = WavCallDir & ATVoice & Mid(AnnStn, kCount, 1) & ".wav"
			FileName = CharToPlay
			GetWavFileTime(FileName)
			CharToPlayTime = WavFileTime
		End If
		If ((Mid(AnnStn, kCount, 1) = "-") OR (Mid(AnnStn, kCount, 1) = "_")) AND CharToPlayTime = 0 Then
			CharToPlayTime = 300
		Else
			oEchoLink.SendID 3, CharToPlay
		End If
		Err.Clear
		WScript.Sleep CharToPlayTime
	Next

	If AnnStnCon Then
		CharToPlay = WavCallDir & ATVoice & "Con.wav"
		FileName = CharToPlay
		GetWavFileTime(FileName)
		CharToPlayTime = WavFileTime
		oEchoLink.SendID 3, CharToPlay
		Err.Clear
		WScript.Sleep CharToPlayTime
	ElseIf AnnStnLin Then
		CharToPlay = WavCallDir & ATVoice & "Lin.wav"
		FileName = CharToPlay
		GetWavFileTime(FileName)
		CharToPlayTime = WavFileTime
		oEchoLink.SendID 3, CharToPlay
		Err.Clear
		WScript.Sleep CharToPlayTime
	ElseIf AnnStnRep Then
		CharToPlay = WavCallDir & ATVoice & "Rep.wav"
		FileName = CharToPlay
		GetWavFileTime(FileName)
		CharToPlayTime = WavFileTime
		oEchoLink.SendID 3, CharToPlay
		Err.Clear
		WScript.Sleep CharToPlayTime
	End If
	Err.Clear
'	PTTOff
End Sub	




'	################################
'	Ausgabe StationsInfo - DTMF Case
'	################################

Sub StationInfo
	If Not Announcements Then
		Exit Sub
	End If
	If Not oEchoLink.RXSignal AND oEchoLink.NumPeers = 0 Then
		If (CallCount < 120) OR Not GuardCallCount Then
			If (SelCall = NumberOfCallFile) Then
				SelCall = 0
			End If
			SelCall = (SelCall + 1)
			CallToPlay = WavStnCallDir & SelCall & ".wav"
			FileName = CallToPlay
			GetWavFileTime(FileName)
			CallToPlayTime = WavFileTime
			PTTOnDelay
			oEchoLink.SendID 3, CallToPlay
			Err.Clear
			WScript.Sleep (CallToPlayTime + 500)
			If InfoEchoEnab AND ELinkEnab Then
				InfoEchoToPlay = WavInfoEchoDir & "StationInfo1.wav"	' wav-Datei, die zu freigegebenen Zeiten als StationInfo abgespielt wird
				FileName = InfoEchoToPlay
				GetWavFileTime(FileName)
				InfoEchoToPlayTime = WavFileTime				
				oEchoLink.SendID 3, InfoEchoToPlay
				Err.Clear
				WScript.Sleep InfoEchoToPlayTime
			Else
				InfoEchoToPlay = WavInfoEchoDir & "StationInfo2.wav"	' wav-Datei, die zu gesperrten Zeiten als StationInfo abgespielt wird
				FileName = InfoEchoToPlay
				GetWavFileTime(FileName)
				InfoEchoToPlayTime = WavFileTime
				oEchoLink.SendID 3, InfoEchoToPlay
				Err.Clear
				WScript.Sleep InfoEchoToPlayTime
			End If
			PTTOff
			If InfoEchoEnab Then
				CallCount = (CallCount + 20)
			Else
				CallCount = (CallCount + 60)
			End If
		Else
			CallCount = (CallCount + 120)
		End If		
		If CallCount > 1800 Then						' Begrenzung auf 15 Minuten
			CallCount = 1800
		End If
	Else
	End If
	DTMFCommand = ""
	Err.Clear
End Sub



'	#################################
'	Ausgabe Aktuelle Zeit - DTMF Case
'	#################################

Sub ActTimeAnn
	If AnnActTime = 0 Then
		Exit Sub
	ElseIf Not Announcements OR Not ELinkEnab Then
		Exit Sub
	Else
		If Not oEchoLink.RXSignal AND (oEchoLink.NumPeers = 0) Then
			If (CallCount < 120) OR Not GuardCallCount Then
				Stunden = Mid(Time,1,2)
				Minuten = Mid(Time,4,2)
				FileToPlay = WavActTimeDir & Stunden & "uhr.wav"	'Ausgabe Stunde
				FileName = FileToPlay
				GetWavFileTime(FileName)
				FileToPlayTime = WavFileTime
				PTTOnDelay
				oEchoLink.SendID 3, FileToPlay
				Err.Clear
				WScript.Sleep FileToPlayTime
				FileToPlay = WavActTimeDir & Minuten & "min.wav"	'Ausgabe Minute
				FileName = FileToPlay
				GetWavFileTime(FileName)
				FileToPlayTime = WavFileTime
				oEchoLink.SendID 3, FileToPlay
				Err.Clear
				WScript.Sleep FileToPlayTime
				PTTOff
				If InfoEchoEnab Then
					CallCount = (CallCount + 20)
				Else
					CallCount = (CallCount + 60)
				End If
			Else
				CallCount = (CallCount + 120)
			End If		
			If CallCount > 1800 Then					' Begrenzung auf 15 Minuten
				CallCount = 1800
			End If
		End If
	End If
	DTMFCommand = ""
	Err.Clear
End Sub



'	################################
'	Ausgabe Node-Nummer - DTMF Case
'	################################

Sub NodeInfo
	If Not Announcements OR Not ELinkEnab Then
		Exit Sub
	End If
	If Not oEchoLink.RXSignal AND (oEchoLink.NumPeers = 0) Then
		If (CallCount < 1200) OR Not GuardCallCount Then
' 			Nodenummer des Gates ausgeben			' Durch Entfernen oder Setzen der Remarkzeichen auswaehlen
'			oEchoLink.SendID 1, OwnNodeNumber		' "OwnNodeNumber" aus "Function IsStationOnlineAndOnOrBusy(sStation)"
' 			Nodenummer des Gates als Text ausgeben
			InfoEchoToPlay = WavInfoEchoDir & "Node.wav"	' wav-Datei, die die Node-Info abgespielt wird ausgegeben
			FileName = InfoEchoToPlay
			GetWavFileTime(FileName)
			InfoEchoToPlayTime = WavFileTime
			PTTOnDelay
			oEchoLink.SendID 3, InfoEchoToPlay
			Err.Clear
			WScript.Sleep InfoEchoToPlayTime
			PTTOff
			CallCount = (CallCount + 20)
		Else
			CallCount = (CallCount + 60)
		End If
	Else
		CallCount = (CallCount + 120)
	End If
	If CallCount > 1800 Then					' Begrenzung auf 15 Minuten
		CallCount = 1800
	End If
	DTMFCommand = ""
	Err.Clear
End Sub



'	##################################################
'	Disconnect (#, ##) mit Pruefung auf Plausibilitaet
'	##################################################

Sub DisconnectLink
	If ChkDiscLink AND (DiscLink <> 0) AND (oEchoLink.NumPeers = 0) Then
		DiscEvent = -1
		AnnounceDisconnect
		DiscEvent = 0
		DiscLink = 0
		lCount = 0
		Exit Sub
	ElseIf ChkDiscLink AND (DiscLink <> 0) AND (lCount = 0) Then
		lCount = 1
		jCount = 0
		If Not DiscEvent AND Not oEchoLink.RXSignal AND ConnectGuard AND ClearToKillLink  Then	' Abwurf, falls KillLink-Bedingungen zutreffen
			oEchoLink.Disconnect ActConnect
			AutoDisc = 0
			DiscLink = 0
			lCount = 0
			Exit Sub
		ElseIf (RxOrRec > 7) OR (oEchoLink.NumPeers = 0) Then
			AutoDisc = 0
			DiscLink = 0
			lCount = 0
			Exit Sub
		End If
	ElseIf ChkDiscLink AND (DiscLink <> 0) AND (lCount >= 4) Then
		If (jCount < 2) AND (DiscLink = 1) Then
			oEchoLink.SendChatText sStation & " requested disconnect"
			oEchoLink.Disconnect ActConnect			' Disconnect letzte Station, wenn weder Signal von EchoLink noch vom Repeater
		ElseIf (jCount < 2.5) AND (DiscLink = 2) Then
			oEchoLink.SendChatText sStation & " requested disconnect"
			oEchoLink.DisconnectAll				' Disconnect alle Stationen, wenn weder Signal von EchoLink noch vom Repeater
		End If
		AutoDisc = 0
		DiscLink = 0
		lCount = 0
		jCount = 0
		Exit Sub
	ElseIf ChkDiscLink AND (DiscLink <> 0) AND (lCount >= 1) Then
		If oEchoLink.RXSignal OR oEchoLink.Receiving Then
			jCount = (jCount + 0.5)
		End If
		lCount = (lCount + 0.5)
	End If
	Err.Clear
End Sub



'	#######################################
'	Automatischer Disconnect (ConnectGuard)
'	#######################################


Sub AutoDisconnect
	If RepeaterMode AND ConnectGuard AND ClearToKillLink AND oEchoLink.Receiving Then
		If PeersCount > ConnectGuardTime Then						'Zeit, nach der DisconnectAll bei Repeater ausgefuehrt wird, falls Abwurfbedingungen zutreffen
			oEchoLink.SendChatText "Disconnect automatically"
			oEchoLink.DisconnectAll
			AutoDisc = -1
			AgainConnect = (AgainConnect + 90)
		End If
		If (AgainConnect <> 0) AND (PeersCount > (ConnectGuardTime / 2)) Then		'Zeit, nach der DisconnectAll bei Repeater ausgefuehrt wird, falls Abwurfbedingungen zutreffen und es sich um Reconnect (=gleiche EchoLinkStation) handelt
			oEchoLink.SendChatText "Disconnect automatically"
			oEchoLink.DisconnectAll
			AutoDisc = -1
			AgainConnect = (AgainConnect + 90)
		End If
	ElseIf Not RepeaterMode AND ConnectGuard AND ClearToKillLink AND oEchoLink.Receiving Then
		If PeersCount > (ConnectGuardTime * 1.5) Then					'Zeit, nach der DisconnectAll bei User/Link ausgefuehrt wird, falls Abwurfbedingungen zutreffen
			oEchoLink.SendChatText "Disconnect automatically"
			oEchoLink.DisconnectAll
			AutoDisc = -1
		End If
	End If
	If DiscEvent Then
		AnnounceDisconnect
		ChkMaxPeers
		DiscEvent = 0
 	End If
	Err.Clear
End Sub



'	#########################
'	Signalisierung Disconnect
'	#########################

Sub AnnounceDisconnect
	If Not SysAnnELPlus OR oEchoLink.RXSignal OR oEchoLink.Receiving Then
		Exit Sub
	End If
	If DiscEvent AND (RepHoldTimeCount < tRepHoldTime) Then
		If Not AutoDisc AND Not oEchoLink.RXSignal AND Not oEchoLink.Receiving Then
			InfoEchoToPlay = WavInfoEchoDir & "JustDisc.wav"	' wav-Datei, die nach Disconnect abgespielt wird
			If ListenOn Then
				ListenOn = 0
				ConfEchoLink.TimeoutInactivity = bInactivityTimeout
				ConfEchoLink.Apply 0
			End If
		ElseIf AutoDisc Then
			InfoEchoToPlay = WavInfoEchoDir & "JustAutoDisc.wav"	' wav-Datei, die nach automatischem Disconnect (KillLink) abgespielt wird
			If ListenOn Then
				ListenOn = 0
				ConfEchoLink.TimeoutInactivity = bInactivityTimeout
				ConfEchoLink.Apply 0
			End If
		End If
		FileName = InfoEchoToPlay
		GetWavFileTime(FileName)
		InfoEchoToPlayTime = WavFileTime
		If Not oEchoLink.RXSignal Then
			PTTOnDelay
			oEchoLink.SendID 3, InfoEchoToPlay
			Err.Clear
			WScript.Sleep InfoEchoToPlayTime
			PTTOff
		End If
	End If
End Sub



'	###################################
'	Reconnect (DTMF 09) nach Disconnect
'	###################################

Sub ReconnectStation
	If Not oEchoLink.RXSignal AND (ClearToReConnect > 2) AND ELinkEnab AND Not ConnectingCall Then		' Akt. Zaehlerstand (Ausgangsstand siehe Sub ChkStatusRxPTT)
		If bCallIfELBusy AND (MaxPeers = 1) Then
			ConfEchoLink.LocationBusy = sEchoLinkBusyCall & LastConnect	' Anzeige in EchoLink-Stationsliste (mit connecteter Station) wenn "Busy" eine Station zugelassen
			ConfEchoLink.Apply 0
		Else
			ConfEchoLink.LocationBusy = sEchoLinkBusy			' Anzeige in EchoLink-Stationsliste wenn "Busy" durch x EchoLink-Stationen
			ConfEchoLink.Apply 0
		End If
		sConnectingTo = LastConnect
		IsStationOnlineOrBusy
		ConnectingTime = Timer
		DTMFCommand = "*Connecting"
		PlayInfoEchoMisc
		oEchoLink.Connect ConnectingToNode, 0
		ConnectingCall = -1
	End If
	Err.Clear
End Sub



'	################################################
'	Pruefung max. Anzahl EchoLink-Stationen erreicht
'	################################################

Sub ChkMaxPeers
	If Not CheckMaxPeers AND (oEchoLink.NumPeers = MaxPeers) Then
		CheckMaxPeers = -1
		RefreshInterval = 10
	ElseIf CheckMaxPeers AND (oEchoLink.NumPeers < MaxPeers) Then
		CheckMaxPeers = 0
		RefreshInterval = 10
	End If
End Sub



'	#################################################
'	Status&Pruefung Repeater-RxOn/EchoLink - KillLink
'	#################################################

Sub ChkStatusRxPTT
	If  oEchoLink.RXSignal OR oEchoLink.PTT Then
		RepHoldTimeCount = 0
	Else
		RepHoldTimeCount = (RepHoldTimeCount + 0.5)
		If RepHoldTimeCount = 20 Then 
			ConnectingCall = 0				' Ruecksetzung Diff Stationsansage, wenn kein Connect zustande kam
		End If
	End If
	
	If oEchoLink.NumPeers <> 0 AND TimerOn Then
		ClearToReConnect = 0
		PeersCount = (PeersCount + 0.5)
		If oEchoLink.RXSignal Then
			If Not RXOn Then
				RxOnCountS = 1
			End If
			RXOn = -1
			If RepeaterMode Then							' Wenn "-R" EchoLinkStation connected
				If RxOnCountS > 5 Then						' Repeater-Sprechzeit (einzel)
					RxOnCount = (RxOnCount + (80 * oEchoLink.NumPeers))	' Bonus Repeater nach Repeater-Sprechzeit > 5s
				ElseIf RxOnCountS > 2 Then
					RxOnCount = (RxOnCount + (40 * oEchoLink.NumPeers))	' Bonus Repeater nach Repeater-Sprechzeit >
				End If
			ElseIf Not RepeaterMode Then						' Wenn User oder"-L" EchoLinkStation connected
				If RxOnCountS > 5 Then
					RxOnCount = (RxOnCount + (50 * oEchoLink.NumPeers))	' Bonus User nach Repeater-Sprechzeit > 5s
				ElseIf RxOnCountS > 2 Then
					RxOnCount = (RxOnCount + (25 * oEchoLink.NumPeers))	' Bonus User nach Repeater-Sprechzeit > 2s
				End If
			End If
			RxOnCountS = (RxOnCountS + 0.5)
		ElseIf Not oEchoLink.RXSignal Then
			RXOn = 0
		End If
		If oEchoLink.Receiving Then
			If Not RecOn Then
				RecOnCountS = 1
			End If
			RecOn = -1
			RecOnCount = (RecOnCount + 0.5)			' Zeit [s] aller von EchoLink kommenden Sendungen (RecOn)
			RecOnCountS = (RecOnCountS + 0.5)		' Zeit [s] der aktuell von EchoLink kommenden Sendung (RecOn)	
		ElseIf Not oEchoLink.Receiving Then
			If RecOn Then
				RecOffCount = 1
			End If
			RecOn = 0
			RecOffCount = (RecOffCount + 0.5)		' Zeit [s] wenn nichts von EchoLink kommt (RecOff)
		End If
		If (RecOnCountS > 4) AND (RecOffCount > 4) Then		' Zeit [s] (im Beispiel 5 s [> 4 = ab 5]) nachdem nach Beendigung einer (im Beispiel mind. 5 s RecOnCount) dauernden EchoLink-Sendung (RecOff) 
			PeersCount = 1					' auf die Ausgangswerte zurueckgesetzt wird. Damit gelten wieder die Ausgangsbedingungen.
			RecOnCount = 1
			RecOnCountS = 1
			RecOffCount = 1
			RXOn = 0
			RecOn = 0
			ClearToKillLink = 0
		End If
		ValDisconn = ((RxOnCount / PeersCount) / (RecOnCount / PeersCount))
		If (PeersCount < 60) AND (ValDisconn < 0.25) Then	' zeitabhaengige dyn. Anpassung der Trennungsbedingung" (ggf. Wert verringern)
			ClearToKillLink = -1
		ElseIf (PeersCount < 120) AND (ValDisconn < 0.1) Then	' zeitabhaengige dyn. Anpassung der Trennungsbedingung" (ggf. Wert verringern)
			ClearToKillLink = -1
		ElseIf (PeersCount < 180) AND (ValDisconn < 0.05) Then	' zeitabhaengige dyn. Anpassung der Trennungsbedingung" (ggf. Wert verringern)
			ClearToKillLink = -1
		Else
			ClearToKillLink = 0
		End If
	ElseIf oEchoLink.NumPeers = 0 Then
		If ClearToReConnect = 0 Then
			 ClearToReConnect = tReconnectTime		' Zeit [s] zur Moeglichkeit des Reconnects						 ' Zeit fuer Moeglichkeit zum Reconnect (DTMF "09")
		ElseIf ClearToReConnect > 1 Then
			ClearToReConnect = (ClearToReConnect - 0.5)
		End If
		PeersCount = 1
		RxOnCount = 1
		RecOnCount = 1
		RecOffCount = 1
		RecOnCountS = 1
		RXOn = 0
		RecOn = 0
		ClearToKillLink = 0
	End If
	If oEchoLink.RXSignal Then
		ClearToAnn = 0
		ClearToAnnDelay = 10
		AskPreTraff = tAskPreTraffRX		' Zeit [s] vor Ausgabe Zeitansage - wenn Relais-Betrieb stattfand, wird Stationsinfo und Zeitansage unterdrueckt
	ElseIf oEchoLink.NumPeers <> 0 Then
		LocalRxOn = 0				' Siehe "Sub PrioLocalTraff"
		ClearToAnn = 0
		ClearToAnnDelay = 10
		AskPreTraff = tAskPreTraffRec		' Zeit [s] vor Ausgabe Zeitansage - wenn EchoLink-Station connected war, wird Stationsinfo und Zeitansage unterdrueckt
	End If
	If ClearToAnnDelay <> 0 Then
		ClearToAnnDelay = (ClearToAnnDelay - 0.5)
	ElseIf ClearToAnnDelay = 0 Then
		ClearToAnn = -1
	End If
	If (oEchoLink.NumPeers <> 0) AND (oEchoLink.RXSignal OR oEchoLink.Receiving) Then
		RxOrRec = (RxOrRec + 0.5)
		If (RxOrRec >= 9) Then
			RxOrRec = 10
		End If
	ElseIf (oEchoLink.NumPeers <> 0) AND (RxOrRec >= 0.5) AND Not (oEchoLink.RXSignal OR oEchoLink.Receiving) Then
		RxOrRec = (RxOrRec - 0.5)
	ElseIf (oEchoLink.NumPeers = 0) Then
		RxOrRec = 0
	End If
	
End Sub



'	################################
'	Vorrang Lokaler Repeater-Betrieb 
'	EchoLink-Zugang deaktiviert
'	################################

Sub PrioLocalTraff
	If oEchoLink.RXSignal AND (oEchoLink.NumPeers = 0) Then
 		If LocalRxOnS < (tLocalRxOnS + 2) Then
 			LocalRxOnS = (LocalRxOnS + 0.5)
 		End If
	Else 
		LocalRxOnS = 0
	End If
	If (PrioLocTraff = 0) AND (LocalRxOn < (tLocalRxOn + 1)) AND (LocalRxOnS > tLocalRxOnS) Then
		LocalRxOn = (LocalRxOn + tLocalRxOnS)
	Else
		If (PrioLocTraff = 0) AND (LocalRxOn <> 0) AND (LocalRxOnS = 0) Then
			LocalRxOn = (LocalRxOn - 0.5)			' Rueckzaehler (1 Step = z [s]) wenn RxOff & EchoLink eingeschaltet
		End If
	End If

	If (PrioLocTraff <> 0) AND (LocalRxOn < (tBusyHoldTime + 1)) AND (LocalRxOnS > tLocalRxOnS) Then
		LocalRxOn = (LocalRxOn + tLocalRxOnS)
	Else
		If (PrioLocTraff <> 0) AND (LocalRxOn <> 0) AND (LocalRxOnS = 0) Then
			LocalRxOn = (LocalRxOn - 0.5)			' Rueckzaehler (1 Step = z [s]) wenn RxOff & EchoLink ausgeschaltet
		End If
	End If
	If (PrioLocTraff = 0) AND (LocalRxOn > tLocalRxOn) Then
		LocalRxOn = tBusyHoldTime
		ConfEchoLink.LocationBusy = sLocalBusy			' Anzeige in Stationsliste wenn "Busy"
		ConfEchoLink.Apply 0
		oEchoLink.ListAsBusy = -1				' Eigene Station "Busy" schalten
		PrioLocTraff = 1
		RefreshInterval = 5
	ElseIf ClearPrivSub AND (PrioLocTraff <> 0) AND LocalRxOn < 2 Then
		If (PrioLocTraff = 1) Then
			ConfEchoLink.LocationBusy = sEchoLinkBusy	' Anzeige in Stationsliste wenn "Busy" ActConnect
			ConfEchoLink.Apply 0
			oEchoLink.ListAsBusy = 0			' Eigene Station ist "On"
		End If
		PrioLocTraff = 0
		RefreshInterval = 5
	End If
End Sub



'	####################################
'	Ansage EchoLink ausgeschaltet (Busy)
'	####################################

Sub AnnBusy
	If (AnnBusyTime = 0) Then					' Wenn nicht in Sperrzeit fuer lange Ansage
		InfoEchoToPlay = WavInfoEchoDir & "LinkBusyOn.wav"	' wav-Datei, die nach Schaltung in EchoLinkBusy abgespielt wird
		AnnBusyTime = tAnnBusyTime				' Sperrzeit fuer lange Ansage
	ElseIf (AnnBusyTime <> 0) Then	' Kurze Sytemmeldung
		InfoEchoToPlay = WavInfoEchoDir & "LinkBusy.wav"	' wav-Datei, die nach Schaltung in EchoLinkBusy abgespielt wird
	End If 
	FileName = InfoEchoToPlay
	GetWavFileTime(FileName)
	InfoEchoToPlayTime = WavFileTime
	If AnnBusyS Then
		While oEchoLink.RXSignal
			WScript.Sleep 50
		Wend
		AnnBusyS = 0
		PTTOnDelay
		oEchoLink.SendID 3, InfoEchoToPlay
		Err.Clear
		WScript.sleep InfoEchoToPlayTime
		PTTOff
	End If
End Sub



'	##########################################################################################
'	Temporaer Busy und ohne DTMF (bei wiederholten Connects zu oder von EchoLink ohne Betrieb)
'	##########################################################################################

Sub TempBusy
	If (AgainConnect > 320) Then
		ConfEchoLink.LocationBusy = "STOERUNG - DISTURBANCE"	' Anzeige in Stationsliste wenn "Busy"
		ConfEchoLink.Apply 0
		oEchoLink.ListAsBusy = -1				' Eigene Station "Busy" schalten
		TempBusyS = -1
		AnnBusyS = -1
		While oEchoLink.RXSignal				' Warten bis kein Signal vom Repeater
			WScript.Sleep 50
		Wend
		AgainConnect = 300
		RefreshInterval = 5
		AnnBusy
	ElseIf AgainConnect = 0 Then
		ConfEchoLink.LocationBusy = sEchoLinkBusy		' Anzeige in Stationsliste wenn "Busy" ActConnect
		ConfEchoLink.Apply 0
		oEchoLink.ListAsBusy = 0				' Eigene Station ist "On"
		TempBusyS = 0
		RefreshInterval = 5
	End If
End Sub



'	#############################################################################
'	EchoLink zu bestimmten Zeiten in Status "Busy" schalten und DTMF deaktivieren
'	############################################################################# 

Sub SuspendLocalOnly
	If (ActDay = tLocalOnlyDay) AND (ActHour = tLocalOnlyHourOff) AND (ActMin >= tLocalOnlyMinOff) Then	' Beginn "Busy EchoLink"
		If AdverSwitchOff AND AdverSwOffCount > 1 Then
			AdverSwOffCount = (AdverSwOffCount - 0.5)
		End If
		If (PrioLocTraff <> 0) AND Not SuspLocOnly Then
			SuspLocOnly = -1
		Else
			If Not SuspLocOnly AND (oEchoLink.NumPeers = 0) Then
				ConfEchoLink.LocationBusy = sLocalBusy		' Anzeige in Stationsliste wenn "Busy"
				ConfEchoLink.Apply 0
				oEchoLink.ListAsBusy = -1			' Eigene Station "Busy" schalten
				AdverSwitchOff = -1
				SuspLocOnly = -1
				RefreshInterval = 5
			ElseIf Not SuspLocOnly AND Not AdverSwitchOff AND oEchoLink.NumPeers <> 0 Then
				InfoEchoToPlay = WavInfoEchoDir & "SwitchOffEchoLink.wav"
				oEchoLink.PlayWavFile InfoEchoToPlay, -1	' wird ueber Repeater und EchoLink ausgegeben
				AdverSwitchOff = -1
				AdverSwOffCount = 125
			End If
		End If
		If Not SuspLocOnly AND AdverSwOffCount = 2 Then
			oEchoLink.SendChatText "Disconnect automatically"
			oEchoLink.DisconnectAll
			WScript.Sleep 1000
			ConfEchoLink.LocationBusy = sLocalBusy			' Anzeige in Stationsliste wenn "Busy"
			ConfEchoLink.Apply 0
			oEchoLink.ListAsBusy = -1				' Eigene Station "Busy" schalten
			WScript.Sleep 1000
			AdverSwitchOff = 0
			SuspLocOnly = -1
			AnnBusyS = -1
			AnnBusy	
			RefreshInterval = 5
		End If
	End If
	If (ActDay = tLocalOnlyDay) AND (ActHour = tLocalOnlyHourOn) AND (ActMin = tLocalOnlyMinOn) Then	' Ende "Busy EchoLink"
		If SuspLocOnly AND (PrioLocTraff <> 0) Then
			SuspLocOnly = 0
		ElseIf SuspLocOnly AND (PrioLocTraff <> 1) Then
			ConfEchoLink.LocationBusy = sEchoLinkBusy		' Anzeige in Stationsliste wenn "Busy" ActConnect
			oEchoLink.ListAsBusy = 0				' Eigene Station ist "On"
			SuspLocOnly = 0
			RefreshInterval = 5
		End If
	End If
End Sub



'	############################################################
'	EchoLink zu bestimmten Zeiten abschalten (EchoLink Disabled)
'	############################################################

Sub EchoLinkEnableDisable
	If ELinkEnab Then
		oEchoLink.EnableLink -1
		ELinkEnabAkt = ELinkEnab
		ELinkEnabTrigg = 0
	ElseIf Not ELinkEnab AND (oEchoLink.NumPeers = 0) Then
		oEchoLink.EnableLink 0
		ELinkEnabAkt = ELinkEnab
		ELinkEnabTrigg = 0
	End If
End Sub



'	##########################
'	Ansagen Infos / Hilfetexte
'	##########################

Sub PlayInfoEcho
	length = Len(DTMFCommand) - 1
	InfoEchoToPlay = WavInfoEchoDir & (Right(DTMFCommand, length)) & ".wav"
	FileName = InfoEchoToPlay
	GetWavFileTime(FileName)
	InfoEchoToPlayTime = WavFileTime

'	+++++++++++++++++++++++++++++++++++++++++++++++++++++
'	Konfiguration Ansage Hilfetexte & Zeitbeschraenkungen
'	+++++++++++++++++++++++++++++++++++++++++++++++++++++
	If InfoEcho = 0 Then
		Exit Sub
	ElseIf Not Announcements OR Not ELinkEnab Then
		Exit Sub
	End If
	If InfoEcho = 2 Then
		If Not InfoEchoEnab Then
			Exit Sub
		End If
	End If
	If (InfoEcho = 1) OR (InfoEcho = 2) Then
		If Not oEchoLink.RXSignal AND (oEchoLink.NumPeers = 0) Then
			If (CallCount < 600) OR Not GuardCallCount Then
				PTTOnDelay
				oEchoLink.SendID 3, InfoEchoToPlay
				Err.Clear
				WScript.Sleep InfoEchoToPlayTime
				PTTOff
				If InfoEchoEnab Then
					CallCount = (CallCount + 20)
				Else
					CallCount = (CallCount + 40)
				End If
			ElseIf CallCount > 600 Then
				CallCount = (CallCount + 120)
			End If
			If CallCount > 1800 Then		' Begrenzung auf 15 Minuten
				CallCount = 1800
			End If
		End If
	End If
	If InfoEchoBeep Then
		WScript.Sleep 500
		FileToPlay = WavInfoEchoDir & "Beep.wav"
		FileName = FileToPlay
		GetWavFileTime(FileName)
		FileToPlayTime = WavFileTime
		oEchoLink.SendID 3, FileToPlay
		Err.Clear
		WScript.Sleep FileToPlayTime
	End If
	Err.Clear
	DTMFCommand = ""
	WScript.Sleep 500		' ###### NEU ###### zur Vermeidung doppelter Ansage langer Texte
End Sub



'	#######################
'	Signalisierung diverses
'	#######################

Sub PlayInfoEchoMisc
	If Not SysAnnELPlus OR (DTMFCommand = "") OR oEchoLink.RXSignal OR oEchoLink.Receiving Then
		Exit Sub
	End If
	If FirstEcho < 3 AND (TransferStatList = 0) Then	' Gegen zu haeufige Ansagen
		If DTMFCommand = "*Error" Then					' Nur Tonfolge
			DTMFCommand = "*LError"						' Tonfolge + Erlaeuterung
		ElseIf DTMFCommand = "*NotFound" Then
			DTMFCommand = "*LNotFound"
		ElseIf DTMFCommand = "*StationBusy" Then
			DTMFCommand = "*LStationBusy"
		ElseIf DTMFCommand = "*Deny" Then
			DTMFCommand = "*LDeny"
		ElseIf DTMFCommand = "*Connecting" Then
			DTMFCommand = "*LConnecting"
		ElseIf DTMFCommand = "*LocalBusy" Then
			DTMFCommand = "*LLocalBusy"
		ElseIf DTMFCommand = "*Denied" Then
			DTMFCommand = "*LDenied"
		End If
	End If

	FirstEcho = (FirstEcho + 1)

	If (FirstEcho > 7) Then
			FirstEcho = 7
	End If

	If DTMFCommand = "*ConnectingS" Then
		DTMFCommand = "*Connecting"
		If (FirstEcho > 1) Then
			FirstEcho = (FirstEcho - 1)
		End If
	End If

	length = Len(DTMFCommand) - 1
	InfoEchoToPlay = WavInfoEchoDir & Right(DTMFCommand, length) & ".wav"
	FileName = InfoEchoToPlay
	GetWavFileTime(FileName)
	InfoEchoToPlayTime = WavFileTime

	If InfoEcho = 0 Then
		Exit Sub
	ElseIf Not Announcements OR Not ELinkEnab Then
		Exit Sub
	End If

	If Not oEchoLink.RXSignal Then
		If (CallCount < 600) OR Not GuardCallCount Then
			PTTOnDelay
			oEchoLink.SendID 3, InfoEchoToPlay
			Err.Clear
			WScript.Sleep InfoEchoToPlayTime
			If InfoEchoEnab Then
				CallCount = (CallCount + 20)
			Else
				CallCount = (CallCount + 40)
			End If
			PTTOff
		ElseIf CallCount > 300 Then
			CallCount = (CallCount + 120)
		End If
		If CallCount > 1800 Then			' Begrenzung auf 15 Minuten
			CallCount = 1800
		End If
	End If
	Err.Clear
	DTMFCommand = ""
End Sub



'	##################################################
'	Initialisierung stuendliche/halbstuendliche Ansage
'	##################################################

Sub AnnBegin

	doneAnnCall = -1
	doneTimeSignal = -1
	doneAnnTime = -1
	doneAnnActMsg = -1

	If (AnnCall = 0) AND (AnnTimeSig = 0) AND (AnnTime = 0) AND (AnnActMsg = 0) Then
		Exit Sub
	End If

	If (((ActMin = 59) AND (AnnActMsg <> 0)) OR ((ActMin = 29) AND (AnnActMsg = 2))) Then
		tPreOpenRepSI = (65 - tPreOpenRepTS - (Int(tPreOpenRepDur / 1000)))
		AnnTimeEnab = -1
	 	doneAnnActMsg = 0
	End If

	If (((ActMin = 59) AND (AnnTime <> 0)) OR ((ActMin = 29) AND (AnnTime = 2))) Then
		tPreOpenRepSI = (62 - tPreOpenRepTS - (Int(tPreOpenRepDur / 1000)))
		AnnTimeEnab = -1
	 	doneAnnTime = 0
	End If

	If (((ActMin = 59) AND (AnnTimeSig <> 0)) OR ((ActMin = 29) AND (AnnTimeSig = 2))) Then
		tPreOpenRepSI = (51 - tPreOpenRepTS - (Int(tPreOpenRepDur / 1000)))
		AnnTimeEnab = -1
	 	doneTimeSignal = 0
	End If

	If (((ActMin = 59) AND (AnnCall <> 0)) OR ((ActMin = 29) AND (AnnCall = 2))) Then
		If (SelCall = NumberOfCallFile) Then
			SelCall = 0
		End If
		SelCall = (SelCall + 1)
		CallToPlay = WavStnCallDir & SelCall & ".wav"
		FileName = CallToPlay
		GetWavFileTime(FileName)
		CallWavFileTime = WavFileTime
		tPreOpenRepSI = (51 - (Int(WavFileTime / 1000)) - tPreOpenRepTS - (Int(tPreOpenRepDur / 1000)))
		tAnnCall = (51 - (Int(WavFileTime / 1000)))
		If AnnTimeSig = 0 Then
			tPreOpenRepSI = (tPreOpenRepSI + 5)
			tAnnCall = (tAnnCall + 5)
		End If
		doneAnnCall = 0
		AnnTimeEnab = -1
	End If
End Sub




'	##########################
'	Relais vor Ansagen oeffnen
'	##########################

Sub PreOpenRep
	If ClearToAnn Then
		PTTOn
		If (PreOpenRepeater = 2) Then
			oEchoLink.SendToneBurst 1750, tPreOpenRepDur		' Tonruf Frequenz [Hz], Dauer [ms]
		Else
			WScript.Sleep tPreOpenRepDur				' Dauer [ms] Traeger (ohne Tonruf), z. B. bei CTCSS-Auswertung
		End If
		PTTOff
	End If
End Sub



'	########################
'	Ansage Relais-Rufzeichen
'	########################

Sub pAnnStn
	If ClearToAnn OR OpenRep Then	
		PTTOn
		oEchoLink.SendID 3, CallToPlay
		Err.Clear
		WScript.Sleep CallWavFileTime
		doneAnnCall = -1
	End If
End Sub



'	###################
'	Ausgabe Zeitzeichen
'	###################

Sub pTimeSignal
	If oEchoLink.RXSignal OR oEchoLink.Receiving Then
		doneTimeSignal = -1
		Exit Sub
	End If
	PTTOn
	If (ActMin = 29) Then
		ToneFrequ = 400
	Else
		ToneFrequ = 800
	End If	
	GetActTime = Timer
	DActsec = Fix((((GetActTime * 1000) MOD 86400000) MOD 3600000) MOD 60000)
	Do While DActsec <= (56000 - tAudioDelay)	'Start Zeitzeichen 1. Zeichen - bei AudioDelay entsprechend verringern (z. B. bei 125 ms AudioDelay auf 55875)
		GetActTime = Timer
		DActsec = Fix((((GetActTime * 1000) MOD 86400000) MOD 3600000) MOD 60000)
	Loop
	For iCount = 1 To 4
		oEchoLink.SendToneBurst ToneFrequ, 120
		WScript.Sleep 1000
	Next
		oEchoLink.SendToneBurst ToneFrequ, 400
		WScript.Sleep 500
	doneTimeSignal = -1
End Sub



'	#############################################
'	Ansage Aktuelle Zeit zur vollen/halben Stunde
'	#############################################

Sub pAnnTime
	If oEchoLink.RXSignal OR oEchoLink.Receiving Then
		doneAnnTime = -1
		Exit Sub
	End If
	If (AnnTimeVoice = 0) Then
		Randomize Timer
		ATV = Int((2 * Rnd) + 1)
		If ATV = 1 Then 
			ATVoice = "M"
		Else
			ATVoice = "F"
		End If
	ElseIf AnnTimeVoice = 1 Then
		ATVoice = "M"
	ElseIf AnnTimeVoice = 2 Then
		ATVoice = "F"
	ElseIf (((ActMin = 0) AND (AnnTimeVoice = 3) OR (AnnTimeVoice = 4) OR (AnnTimeVoice = 5)) OR ((ActMin = 30) AND (AnnTimeVoice = 3))) Then
		length = Len(SelCallMaleFemale)
		sChar = ""
		For iCount = 1 To length
			sCharX = Mid(SelCallMaleFemale, iCount, 1)
			If sCharX <> "," Then
				sChar = sChar & sCharX
					If CInt(sChar) = SelCall Then
						ATVoice = "M"
						Exit For
					Else
						ATVoice = "F"
					End If
			Else
				sChar = ""
			End If       
		Next
	End If
	If (AnnTimeVoice = 4) AND (ActMin = 30) Then
		ATVoice = "M"
	ElseIf (AnnTimeVoice = 5) AND (ActMin = 30) Then
		ATVoice = "F"
	End If
	TimeToPlay = WavTimeDir & ATVoice & ActHour & ".wav"
	FileName = TimeToPlay
	GetWavFileTime(FileName)
	TimeToPlayTime = WavFileTime
	MinToPlay = WavTimeDir & ATVoice & "30.wav"
	FileName = MinToPlay
	GetWavFileTime(FileName)
	MinToPlayTime = WavFileTime
	PTTOnDelay
	If (ActMin = 30) Then
		oEchoLink.SendID 3, TimeToPlay
		Err.Clear
		WScript.Sleep TimeToPlayTime
		oEchoLink.SendID 3, MinToPlay
		Err.Clear
		WScript.Sleep MinToPlayTime
		doneAnnTime = -1
	ElseIf (ActMin = 0) Then
		oEchoLink.SendID 3, TimeToPlay
		Err.Clear
		WScript.Sleep TimeToPlayTime
		doneAnnTime = -1
	End If
End Sub



'	##########################
'	Ansage Aktuelle Mitteilung
'	##########################

Sub pAnnActMsg
' Selection der aktuellen Mitteilung, die nach der StationsInfo und der
' Zeitansage abgespielt werden soll.
	If oEchoLink.RXSignal OR oEchoLink.Receiving Then
		doneAnnActMsg = -1
		Exit Sub
	End If
	If AnnActMsgSysOp Then
		Randomize Timer
		SelActMsg = Int((NumberActMsg * Rnd) + 1)
		MsgToPlay = WavActMsgDir & SelActMsg & ".wav"
		FileName = MsgToPlay
		GetWavFileTime(FileName)
		MsgToPlayTime = WavFileTime
		PTTOn
		oEchoLink.SendID 3, MsgToPlay
		Err.Clear
		WScript.Sleep MsgToPlayTime
		PTTOff
		End If
	doneAnnActMsg = -1
End Sub



Sub PTTOn
	If PTTSwitchEnable AND Not oEchoLink.PTT Then
		oEchoLink.PTTControl -1
	End If
	ClearPrivSub = 0
End Sub



Sub PTTOnDelay
	If PTTSwitchEnable AND Not oEchoLink.PTT Then
		oEchoLink.PTTControl -1
		WScript.Sleep 300
	End If
	ClearPrivSub = 0
End Sub



Sub PTTOff
	If PTTSwitchEnable AND oEchoLink.PTT Then
		oEchoLink.PTTControl 0
	End If
	ClearPrivSub = -1
End Sub



'	###################################
'	EchoLinkRx aktiv - Repeater oeffnen
'	###################################

Sub EchoLink_RX(bRX)
	If bRX AND (PreOpenRepeater = 2) AND (RepHoldTimeCount > (tRepHoldTime + tRepPostTime)) Then
		oEchoLink.SendToneBurst 1750, tPreOpenRepDur		' Tonruf Frequenz [Hz], Dauer [ms]
	End If
	bRX = 0
End Sub




'	##############################
'	Refresh EchoLink-Stationsliste
'	##############################

Sub RefreshStnList
	If ClearPrivSub AND Not AnnTimeEnab AND Not ConnectingCall AND Not StationListRec Then
		If Not UpdateInQSOELP AND (oEchoLink.Receiving OR oEchoLink.RXSignal) Then	'Unterbindet Refresh wenn StnListRefresh waehrend QSO nicht erlaubt
			Exit Sub
		ElseIf ELinkEnab Then
			oEchoLink.RefreshStationList -1
			If AutoUpdateELP Then
				RefreshInterval = RefreshIntervalELP	' StnListRefresh durch EchoLinkPlus - setzt Refresh-Intervall auf eingestellten Wert [s]
			Else
				RefreshInterval = 0			' StnListRefresh durch EchoLink - schaltet Intervall aus (neue Anforderung durch entspr. Event)
			End If
		End If
	End If
End Sub



'	########
'	Watchdog
'	########
'	Fuehrt einen Reset von EchoLink.exe aus falls PTT mal 'haengen' bleibt

Sub Watchdog
	If oEchoLink.PTT AND Not oEchoLink.Receiving Then
		PTTWDCount = (PTTWDCount + 1)
	Else
		PTTWDCount = 1
	End If
	If PTTWDCount > 240 Then 	' Reset nach 120 sec
		oEchoLink.Reset
		ClearPrivSub = -1
		PTTWDCount = 1
	End If 
End Sub



'	################
'	Popup-Mitteilung
'	################

Sub PopupMessage
	Set oWshShell = WScript.CreateObject("WScript.Shell")
	oWshShell.Popup PopupMsg, 5, sStation & Header, 48
	WScript.DisconnectObject(oWshShell)
	Set oWshShell = Nothing
End Sub



'	#################
'	Station connected
'	#################

Sub EchoLink_Connected(sConnectedStation, sName, sAddr)
	ActConnect = sConnectedStation
	StationConnected = -1
	If	Not ConnectingCall AND bCallIfELBusy AND (MaxPeers = 1) Then
		ConfEchoLink.LocationBusy = sEchoLinkBusyCall & ActConnect	' Anzeige in EchoLink-Stationsliste (mit connecteter Station) wenn "Busy" eine Station zugelassen
		ConfEchoLink.Apply 0
	ElseIf Not ConnectingCall Then 
		ConfEchoLink.LocationBusy = sEchoLinkBusy			' Anzeige in EchoLink-Stationsliste wenn "Busy" durch x EchoLink-Stationen
		ConfEchoLink.Apply 0
	End If
 End Sub

Sub StnConnected
	If ClearPrivSub Then
		JustConnected = -1
		StationMode = Right(ActConnect, 2)
		If StationMode = "-R" Then
			RepeaterMode = -1
		Else
			RepeaterMode = 0
		End If
		If Not RepeaterMode Then
			StationMode = Left(ActConnect, 1)
			If StationMode = "*" Then
				RepeaterMode = -1
			End If
		End If
		If AutoDisc AND (ActConnect = LastConnect) Then
			AgainConnect = (AgainConnect + 90)
			AutoDisc = 0
		Else
			AgainConnect = 0
			AutoDisc = 0
		End If
		StationConnected = 0
		oEchoLink.SendChatText "EchoLink+ V2.1.5b"
	End If
End Sub




'	####################
'	Station disconnected
'	####################

Sub EchoLink_Disconnected(sDisconnectingStation)
	LastConnect = sDisconnectingStation				' zuletzt disconnectete Station 
	DiscEvent = -1
End Sub




'	#######################
'	Stationsliste empfangen
'	#######################

Sub	EchoLink_StationListReceived
	If ELinkEnab Then
		StationListRec = -1
		If AutoUpdateELP Then
			RefreshInterval = RefreshIntervalELP		' StnListRefresh durch EchoLinkPlus - setzt Refresh-Intervall auf eingestellten Wert [s]
		Else
			RefreshInterval = 0				' StnListRefresh durch EchoLink - schaltet Intervall aus (neue Anforderung durch entspr. Event)
		End If
	End If
End Sub


'	##############
'	Reset EchoLink
'	##############
'	Fuehrt einen Reset aus, Wenn die Bedingung "IsStationOnlineAndOnOrBusy = -1" (=eigene Station) NICHT erfuellt ist:

Sub StationListReceivd
	If (oEchoLink.NumPeers <> 0) Then	'verhindert Reset waehrend EchoLink-Station connected
		Exit Sub
	End If
	
	If ClearPrivSub AND ChkLinkRes AND Not IsStationOnlineAndOnOrBusy(sStation) Then
		oEchoLink.Reset
		WScript.Sleep 1000
		ClearPrivSub = -1
		PTTWDCount = 1
	End If

	If (sStationStatus = "BUSY") AND Not SuspLocOnly AND Not TempBusyS AND (PrioLocTraff <> 1) AND (oEchoLink.NumPeers <> MaxPeers) Then
		oEchoLink.ListAsBusy = 0
		WScript.Sleep 1000
		If Not IsStationOnlineAndOnOrBusy(sStation) Then
			oEchoLink.Reset
			WScript.Sleep 1000
			ClearPrivSub = -1
			PTTWDCount = 1
		End If
	End If

	Set oWshShell = WScript.CreateObject("WScript.Shell")
	sLocationFree = oWshShell.RegRead(RegKeyEL & "Options\LocationFree")
	WScript.DisconnectObject(oWshShell)
	Set oWshShell = Nothing
	If sLocationFree = "Waiting for update" Then
		LoadConfig
		oEchoLink.Reset
		WScript.Sleep 1000
		ClearPrivSub = -1
		PTTWDCount = 1
	End If
End Sub




'	################################
'	Konfiguration aus Registry lesen
'	################################

Sub LoadConfig
	Err.Clear
	Set oWshShell = WScript.CreateObject("WScript.Shell")
	StartupProfile = oWshShell.RegRead("HKCU\Software\K1RFD\EchoLink\StartupProfile")
	PathEchoLink = oWshShell.RegRead("HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\EchoLink.exe\Path")
	
 	If StartupProfile = "MAIN" Then
		RegKeyEL = "HKCU\Software\K1RFD\EchoLink\"
		RegKeyELP = "HKCU\Software\K1RFD\EchoLink\EchoLinkPlus\"
	Else
		RegKeyEL = "HKCU\Software\K1RFD\EchoLink\Profiles\" & StartupProfile & "\EchoLink\"
		RegKeyELP = "HKCU\Software\K1RFD\EchoLink\Profiles\" & StartupProfile & "\EchoLink\EchoLinkPlus\"
	End If

	ChkLinkRes = oWshShell.RegRead(RegKeyELP & "ChkLinkRes")
	RefreshIntervalELP = oWshShell.RegRead(RegKeyELP & "RefreshIntervalELP")
	AutoUpdateELP = oWshShell.RegRead(RegKeyELP & "AutoUpdateELP")
	UpdateInQSOELP = oWshShell.RegRead(RegKeyELP & "UpdateInQSOELP")
	PreCmdDTMF = oWshShell.RegRead(RegKeyELP & "PreCmdDTMF")
	PreCmdChar = oWshShell.RegRead(RegKeyELP & "PreCmdChar")
	ErrorCheck = oWshShell.RegRead(RegKeyELP & "ErrorCheck")
	PriorLocalTraff = oWshShell.RegRead(RegKeyELP & "PriorLocalTraff")
	SuspLocalOnly = oWshShell.RegRead(RegKeyELP & "SuspLocalOnly")
	SuspTemp = oWshShell.RegRead(RegKeyELP & "SuspTemp")
	QuickConnect = oWshShell.RegRead(RegKeyELP & "QuickConnect")
	sLinkFree = oWshShell.RegRead(RegKeyELP & "sLinkFree")
	sLocalBusy = oWshShell.RegRead(RegKeyELP & "sLocalBusy")
	sEchoLinkBusy = oWshShell.RegRead(RegKeyELP & "sEchoLinkBusy")
	bCallIfELBusy = oWshShell.RegRead(RegKeyELP & "bCallIfELBusy")
	Password = oWshShell.RegRead(RegKeyELP & "Password")
	tRepHoldTime = oWshShell.RegRead(RegKeyELP & "tRepHoldTime")
	tReconnectTime = oWshShell.RegRead(RegKeyELP & "tReconnectTime")
	tAnnBusyTime = oWshShell.RegRead(RegKeyELP & "tAnnBusyTime")
	tLocalRxOn = oWshShell.RegRead(RegKeyELP & "tLocalRxOn")
	tLocalRxOnS = oWshShell.RegRead(RegKeyELP & "tLocalRxOnS")
	tBusyHoldTime = oWshShell.RegRead(RegKeyELP & "tBusyHoldTime")
	tSuspTempOff = oWshShell.RegRead(RegKeyELP & "tSuspTempOff")
	tSuspTempOn = oWshShell.RegRead(RegKeyELP & "tSuspTempOn")
	tInfoEchoOff = oWshShell.RegRead(RegKeyELP & "tInfoEchoOff")
	tInfoEchoOn = oWshShell.RegRead(RegKeyELP & "tInfoEchoOn")
	tLocalOnlyDay = oWshShell.RegRead(RegKeyELP & "tLocalOnlyDay")
	tLocalOnlyHourOff = oWshShell.RegRead(RegKeyELP & "tLocalOnlyHourOff")
	tLocalOnlyMinOff = oWshShell.RegRead(RegKeyELP & "tLocalOnlyMinOff")
	tLocalOnlyHourOn = oWshShell.RegRead(RegKeyELP & "tLocalOnlyHourOn")
	tLocalOnlyMinOn = oWshShell.RegRead(RegKeyELP & "tLocalOnlyMinOn")
	ChkDiscLink = oWshShell.RegRead(RegKeyELP & "ChkDiscLink")
	ConnectGuard = oWshShell.RegRead(RegKeyELP & "ConnectGuard")
	GuardAutoDiscAgain = oWshShell.RegRead(RegKeyELP & "GuardAutoDiscAgain")
	GuardCallCount = oWshShell.RegRead(RegKeyELP & "GuardCallCount")
	Announcements = oWshShell.RegRead(RegKeyELP & "Announcements")
	AnnIfNotTraff = oWshShell.RegRead(RegKeyELP & "AnnIfNotTraff")
	AnnIfNotRxOn = oWshShell.RegRead(RegKeyELP & "AnnIfNotRxOn")
	AnnCall = oWshShell.RegRead(RegKeyELP & "AnnCall")
	AnnTimeSig = oWshShell.RegRead(RegKeyELP & "AnnTimeSig")
	AnnTime = oWshShell.RegRead(RegKeyELP & "AnnTime")
	AnnTimeVoice = oWshShell.RegRead(RegKeyELP & "AnnTimeVoice")
	AnnActMsg = oWshShell.RegRead(RegKeyELP & "AnnActMsg")
	NumberActMsg = oWshShell.RegRead(RegKeyELP & "NumberActMsg")
	PreOpenRepeater = oWshShell.RegRead(RegKeyELP & "PreOpenRepeater")
	AnnActTime = oWshShell.RegRead(RegKeyELP & "AnnActTime")
	InfoEcho = oWshShell.RegRead(RegKeyELP & "InfoEcho")
	InfoEchoBeep = oWshShell.RegRead(RegKeyELP & "InfoEchoBeep")
	tAskPreTraffRX = oWshShell.RegRead(RegKeyELP & "tAskPreTraffRX")
	tAskPreTraffRec = oWshShell.RegRead(RegKeyELP & "tAskPreTraffRec")
	tAudioDelay = oWshShell.RegRead(RegKeyELP & "tAudioDelay")
	tPreOpenRepTS = oWshShell.RegRead(RegKeyELP & "tPreOpenRepTS")
	tPreOpenRepDur = oWshShell.RegRead(RegKeyELP & "tPreOpenRepDur")
	WavCallDir = oWshShell.RegRead(RegKeyELP & "WavCallDir")
	WavInfoEchoDir = oWshShell.RegRead(RegKeyELP & "WavInfoEchoDir")
	WavTimeDir = oWshShell.RegRead(RegKeyELP & "WavTimeDir")
	WavActTimeDir = oWshShell.RegRead(RegKeyELP & "WavActTimeDir")
	WavActMsgDir = oWshShell.RegRead(RegKeyELP & "WavActMsgDir")
 	WavStnCallDir = oWshShell.RegRead(RegKeyELP & "WavStnCallDir")
	SysAnnELPlus = oWshShell.RegRead(RegKeyELP & "SysAnnELPlus")
	NumberOfCallFile = oWshShell.RegRead(RegKeyELP & "NumberOfCallFile")
	SelCallMaleFemale = oWshShell.RegRead(RegKeyELP & "SelCallMaleFemale")
	SelCallMaleFemale = (SelCallMaleFemale & ",")
	SelAnnMaleFemale = oWshShell.RegRead(RegKeyELP & "SelAnnMaleFemale")
	AnnounceHour = oWshShell.RegRead(RegKeyELP & "AnnounceHour")
	AnnIfNotEnabEL = oWshShell.RegRead(RegKeyELP & "AnnIfNotEnabEL")
	ShortCutDir = oWshShell.RegRead(RegKeyELP & "ShortCutDir")
	ConnectGuardTime = oWshShell.RegRead(RegKeyELP & "ConnectGuardTime")
	PTTSwitchEnable = oWshShell.RegRead(RegKeyELP & "PTTSwitchEnable")
	tRepPostTime = oWshShell.RegRead(RegKeyELP & "tRepPostTime")
	DispBusy = oWshShell.RegRead(RegKeyELP & "DispBusy")
	DispInactTimeout = oWshShell.RegRead(RegKeyELP & "DispInactTimeout")
	bReceivetimeout = oWshShell.RegRead(RegKeyEL & "Options\TimeoutRXLen")
	bTransmitTimeout = oWshShell.RegRead(RegKeyEL & "Options\TimeoutTXLen")
	bTimeoutTrying = oWshShell.RegRead(RegKeyEL & "Options\TimeoutTrying")
	sLocationFree = oWshShell.RegRead(RegKeyEL & "Options\LocationFree")
	bInactivityTimeout = oWshShell.RegRead(RegKeyEL & "Options\TimeoutRXAudio")
	sStatusELP = oWshShell.RegRead(RegKeyELP & "sStatusELP")
	sReconnectELP = oWshShell.RegRead(RegKeyELP & "sReconnectELP")
	sEchoLinkBusyCall = oWshShell.RegRead(RegKeyELP & "sEchoLinkBusyCall")

	If (bReceivetimeout = 0) AND (bTransmitTimeout = 0) AND (bInactivityTimeout = 0) Then	'Wiederherstellung der urspruenglichen Zeiten
		bReceivetimeout = oWshShell.RegRead(RegKeyELP & "TimeoutRXLen")
		bTransmitTimeout = oWshShell.RegRead(RegKeyELP & "TimeoutTXLen")
		bInactivityTimeout = oWshShell.RegRead(RegKeyELP & "TimeoutRXAudio")
		oWshShell.RegWrite RegKeyEL & "Options\TimeoutRXLen", bReceivetimeout, "REG_DWORD"
		oWshShell.RegWrite RegKeyEL & "Options\TimeoutTXLen", bTransmitTimeout, "REG_DWORD"
		oWshShell.RegWrite RegKeyEL & "Options\TimeoutRXAudio", bInactivityTimeout, "REG_DWORD"
		ConfEchoLink.TimeoutReceiveLimit = bReceivetimeout
		ConfEchoLink.TimeoutTransmitLimit = bTransmitTimeout
		ConfEchoLink.TimeoutInactivity = bInactivityTimeout
		ConfEchoLink.Apply 0
	Else
		bReceivetimeout = oWshShell.RegRead(RegKeyELP & "TimeoutRXLen")
		bTransmitTimeout = oWshShell.RegRead(RegKeyELP & "TimeoutTXLen")
		bInactivityTimeout = oWshShell.RegRead(RegKeyELP & "TimeoutRXAudio")
	End If

	MaxPeers = oWshShell.RegRead(RegKeyEL & "Options\MaxPeers")
	BannedCallsign = oWshShell.RegRead(RegKeyEL & "Options\BannedCalls")
	CallsignDeny = oWshShell.RegRead(RegKeyEL & "Options\CallsignsDeny")
	CloseELP = 0
	oWshShell.RegWrite RegKeyELP & "CloseELP", CloseELP, "REG_SZ"
	oWshShell.RegWrite RegKeyEL & "Options\LocationFree", sLinkFree, "REG_SZ"

	If (Err.Number = 0) AND Not StationListRec Then
		oWshShell.Popup "Willkommen zu  E c h o L i n k +  2.1.5b" & (Chr(13) & Chr(10) & Chr(10)) & "Zusatzprogramm zu EchoLink.exe von K1RFD," & (Chr(13) & Chr(10)) & "fr die Besonderheiten des automatischen Betriebs." & (Chr(13) & Chr(10) & Chr(10) & Chr(10)) & "Das Programm wurde erfolgreich geladen, und wird nun ausgefhrt.", 4, sStation & Header, 64
	End If
 
	WScript.DisconnectObject(oWshShell)
	Set oWshShell = Nothing
End Sub




'	#########################################################
'	Pruefung ob Kurzwahl vorhanden und Zuweisung fuer Connect
'	#########################################################

Function IsShortCut(Digits)
	ShortCut = 0
	Set FileSysObj = CreateObject("Scripting.FileSystemObject")
	Set ShortCutFile = FileSysObj.OpenTextFile(ShortCutDir)
	Do While Not ShortCutFile.AtEndOfStream
   		ShortCutList = ShortCutFile.ReadLine()
		If ((Left(ShortCutList, 3)) = Digits) AND (Not (Left(ShortCutList, 1)) = "'") Then
			sConnectingTo = Mid(ShortCutList, 5)
			ShortCutFile.close
			Set ShortCutFile = Nothing
			ShortCut = -1
			Exit Do
		End If
	Loop	
End Function



'	##############################
'	Eigene Station online Pruefung
'	##############################

Function IsStationOnlineAndOnOrBusy(sStation)
	If ChkLinkRes Then
		IsStationOnlineAndOnOrBusy = 0
		For SearchCount = 0 To 6000
			If aStationList(SearchCount, 0) = sStation Then
				If (aStationList(SearchCount, 2) = "ON") OR (aStationList(SearchCount, 2) = "BUSY") Then
					IsStationOnlineAndOnOrBusy = -1
					OwnNodeNumber = aStationList(SearchCount, 1)
					sStationStatus = aStationList(SearchCount, 2)
				End If
				Exit For
			End If
		Next
		If Not IsStationOnlineAndOnOrBusy Then
			Set oStations = oEchoLink.StationEntries
			For Each oStation In oStations
				If oStation.callsign = sStation Then 
					If (oStation.Status = "ON") OR (oStation.Status = "BUSY") Then
						IsStationOnlineAndOnOrBusy = -1
						OwnNodeNumber = oStation.NodeNumber
						sStationStatus = oStation.Status
					End If
					Exit For
				End If
			Next
		End If
	End If

End Function




'	###################
'	Zeitdauer wav-Datei
'	###################

Function GetWavFileTime(FileName)
	Err.Clear
	Set FileSO = CreateObject("Scripting.FileSystemObject")
	If Not (FileSO.FileExists(FileName)) Then
		If (Mid(AnnStn, kCount, 1) = "-") OR (Mid(AnnStn, kCount, 1) = "_") Then
			WavFileTime = 0
		Else
			PTTOn
			WScript.Sleep 500
			For iCount = 1 To 8
				oEchoLink.SendToneBurst 500, 75
				WScript.Sleep 150
			Next
			PTTOff		
			Err.Clear
			WavFileTime = 0
			PopupMsg = "Die Datei " & FileName & " wurde nicht gefunden." & (Chr(13) & Chr(10) & Chr(10)) & "berprfen Sie Dateinamen und DateiPfad"  & (Chr(13) & Chr(10)) & "und versuchen Sie es erneut."
			PopupMessage
		End If
	Else
		Set FileN = FileSO.GetFile(FileName)
		WavFileTime = (Int(FileN.size / 8) + 1)			'Zeitdauer wav-File [ms]
	End If
	WScript.DisconnectObject(FileSO)
	Set FileSO = Nothing
End Function




